SystemOrganization addCategory: #Continuation!


Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Continuation'!

Continuation class
	instanceVariableNames: ''!


!Continuation commentStamp: 'spfa 6/18/2006 22:13' prior: 0!
Continuation class borrowed from Seaside
(author: Avi Bryant) !
]style[(62)f1!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
isContinuation

	^ true! !

!Object methodsFor: '*continuation' stamp: 'spfa 11/18/2009 18:15'!
isContinuation

	^ false! !

!ContextPart methodsFor: '*continuation' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !

!ContextPart methodsFor: '*continuation' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!ContextPart methodsFor: '*continuation' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !
