'From Squeak4.1.1 of 14 April 2010 [latest update: #9948] on 16 April 2010 at 11:42:35 pm'!
PluggableWidgetSpec subclass: #PluggableMorphSpec
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Tools'!

!Browser methodsFor: '*MuO-Projectors' stamp: 'muOuser 4/16/2010 23:24'!
openOnSingleSide

	| builder hSepFrac |

	hSepFrac _ 0.3.
	builder := ToolBuilder default.

	^self buildWindowWith: builder specs: {
		(0@0 corner: 0.3@hSepFrac) -> [self buildMessageCategoryListWith: builder].
		(0.3@0 corner: 1.0@hSepFrac) -> [self buildMessageListWith: builder].
		 (0@hSepFrac corner: 1@1)  -> [self buildCodePaneWith: builder].
	}.
! !


!Browser class methodsFor: 'instance creation' stamp: 'muOuser 4/16/2010 23:24'!
openBrowserView: aBrowserView label: aString color: aColor
	"Schedule aBrowserView, labelling the view aString."
(aBrowserView isKindOf: ToolBuilderSpec) ifTrue:[
	ToolBuilder open: aBrowserView label: aString color: aColor.
] ifFalse:[
	aBrowserView isMorph
		ifTrue:  [(aBrowserView setLabel: aString) openInWorld]
		ifFalse: [aBrowserView label: aString.
				aBrowserView minimumSize: 300 @ 200.
				aBrowserView subViews do: [:each | each controller].
				aBrowserView controller open].
].
	^ aBrowserView model
! !


!MERepositoryBrowser methodsFor: 'construction' stamp: 'muOuser 4/16/2010 23:07'!
buildCodePaneWith: aBuilder

	^ PluggableMorphSpec new morph: (MusicalEditorHolder new model: self)! !


!MorphicToolBuilder methodsFor: 'opening' stamp: 'muOuser 4/16/2010 23:34'!
open: anObject label: aString color: aColor
	"Build an open the object, labeling it appropriately.  Answer the widget opened."
	| window |
	window := self open: anObject.
	window setLabel: aString.
	window setWindowColor: aColor.
	^window! !

!MorphicToolBuilder methodsFor: '*Prolog-tools' stamp: 'spfa 8/16/2009 23:44'!
buildMorphSpec: aSpec

	self setFrame: aSpec frame in: aSpec morph.
	parent ifNotNil:[self add: aSpec morph to: parent].

	^aSpec morph! !


!MuO class methodsFor: 'utilities' stamp: 'muOuser 4/16/2010 23:28'!
browseLibrary: aClass label: aString

	| nb |

	nb _ Browser new.
	nb setClass: aClass selector: nil.
	^ Browser openBrowserView: (nb openOnSingleSide) label: aString color: Color blue muchLighter! !


!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:41'!
buildWith: builder

	^ builder buildMorphSpec: self
	! !

!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:43'!
morph

	^ morph ! !

!PluggableMorphSpec methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2009 23:43'!
morph: aMorph

	morph _ aMorph! !


!ToolBuilder class methodsFor: 'instance creation' stamp: 'muOuser 4/16/2010 23:27'!
open: aClass label: aString color: aColor
	^self default open: aClass label: aString color: aColor! !

