


!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:13'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S.
	Accept the current contents and end editing."
	self updateFromParagraph.
	self editView accept.! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:13'!
autoScrollView: evt
	"This is kind of a hack because the PluggableTextMorph expects me to first expand the selection before auto scrolling will work."
	| localEvt |
	localEvt _ evt transformedBy: (self transformedFrom: self editView).
	super mouseMove: localEvt.
	self editView scrollSelectionIntoView: localEvt.! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:13'!
cancelEdits
	"The message is sent when the user hits enter or Cmd-L.
	Cancel the current contents and end editing."
	self releaseParagraph.
	self editView cancel! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
editView

	"brings 3.9 compatibility to receivers built in a 3.8 image
(TextMorph has a new inst var, editHistory, in 3.9 images)"

	editView isMorph ifFalse: 
	[
		acceptOnCR := editView.
		editView := editHistory.
		editHistory := nil
	].
	^ editView
! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:13'!
flash
	^ self editView flash! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:13'!
handleInteraction: interActionBlock fromEvent: evt
	"Overridden to pass along a model to the editor for, eg, link resolution, doits, etc"

	self editor model: self editView model.  "For evaluateSelection, etc"
	^ super handleInteraction: interActionBlock fromEvent: evt! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
hasUnacceptedEdits: aBoolean
	"Set the hasUnacceptedEdits flag in my view."

	self editView hasUnacceptedEdits: aBoolean! !

!LanguageEnvironment methodsFor: '*MuO39-hacks' stamp: 'spfa 1/20/2007 21:33'!
isFontAvailable

"muO installation short-circuited the code below, sorry for the inconvenience"

"	| encoding |
	encoding _ self leadingChar + 1.
	TextStyle defaultFont fontArray
		at: encoding
		ifAbsent: [^ false]."
	^ true! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
keyStroke: evt
	| view |
	(self editView scrollByKeyboard: evt) ifTrue: [^self].
	self editor model: self editView model.  "For evaluateSelection"
	view _ self editView.  "Copy into temp for case of a self-mutating doit"
	(acceptOnCR and: [evt keyCharacter = Character cr])
		ifTrue: [^ self editor accept].
	super keyStroke: evt.
	view scrollSelectionIntoView! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
mouseDown: event

	event yellowButtonPressed ifTrue: [^ self editView yellowButtonActivity: event shiftPressed].
	^ super mouseDown: event
! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
mouseMove: evt
	| editEvt |
	super mouseMove: evt.
	evt redButtonPressed ifFalse: [^ self].
	editEvt _ evt transformedBy: (self transformedFrom: self editView) inverseTransformation.
	(editEvt position y between: self editView top and: self editView bottom) ifFalse:[
		"Start auto-scrolling"
		self startStepping: #autoScrollView:
			at: Time millisecondClockValue
			arguments: (Array with: editEvt)
			stepTime: 100. "fast enough"
	] ifTrue:[
		self stopSteppingSelector: #autoScrollView:.
	].! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
mouseUp: evt
	super mouseUp: evt.
	self stopSteppingSelector: #autoScrollView:.
	self editView scrollSelectionIntoView: evt.

	self setCompositionWindow.
! !

!CompositionScanner methodsFor: '*MuO39-hacks' stamp: 'spfa 1/24/2007 00:06'!
placeEmbeddedObject: anchoredMorph
	| descent |
	"Workaround: The following should really use #textAnchorType"
	anchoredMorph relativeTextAnchorPosition ifNotNil:[^true].
	
	line ifNil: 
	[	
		line _ TextLineInterval
			start: lastIndex
			stop: 0
			internalSpaces: 0
			paddingWidth: 0.
		lineHeight _ textStyle lineGrid. 
		baseline _ textStyle baseline
	].
	
	(super placeEmbeddedObject: anchoredMorph) ifFalse: [
		"It doesn't fit"
		"But if it's the first character then leave it here"
		lastIndex < line first ifFalse:[
			line stop: lastIndex-1.
			^ false]].

	descent _ lineHeight - baseline.
	lineHeight _ lineHeight max: anchoredMorph height.
	baseline _ lineHeight - descent.
	line stop: lastIndex.
	^ true! !

!TextMorphForEditView methodsFor: '*MuO39-hacks' stamp: 'spfa 1/21/2007 20:14'!
updateFromParagraph  
	super updateFromParagraph.
	self editView setScrollDeltas.! !

!ParagraphEditor class methodsFor: '*MuO39-hacks' stamp: 'spfa 3/9/2007 22:27'!
yellowButtonExpertMenu

	^ MenuMorph fromArray: {
			{'open as box' translated.			#boxIt}.	
			{'open as code box' translated.			#boxItAsDirectValue}.								 			{'open as code box (for output)' translated.	#boxItAsDirectOutput}.	
			#-.
			{'explore lambda refs' translated.	#exploreLambdaReferencesToIt}.
			#-.
			{'make it a button' translated. 	#buttonIt}.
			{'watch it' translated. 	#lambdaWatchIt}.
			#-.																				
			{'set font... (k)' translated.				#offerFontMenu}.
			{'set style... (K)' translated.				#changeStyle}.
			{'set alignment... (u)' translated.		#chooseAlignment}.
			#-.
			{'set font... (k)' translated.				#offerFontMenu}.
			{'set style... (K)' translated.				#changeStyle}.
			{'set alignment... (u)' translated.		#chooseAlignment}.
			#-.
			{'make project link (P)' translated.	#makeProjectLink}.
			#-.
			{'find...(f)' translated.					#find}.
			{'find again (g)' translated.				#findAgain}.
			{'set search string (h)' translated.		#setSearchString}.
			#-.
			{'do again (j)' translated.				#again}.
			{'undo (z)' translated.					#undo}.
			#-.
			{'copy (c)' translated.					#copySelection}.
			{'cut (x)' translated.						#cut}.
			{'paste (v)' translated.					#paste}.
			{'paste...' translated.					#pasteRecent}.
			#-.
			{'do it (d)' translated.					#doIt}.
			{'print it (p)' translated.				#printIt}.
			{'inspect it (i)' translated.				#inspectIt}.
			{'explore it (I)' translated.				#exploreIt}.
			{'debug it' translated.					#debugIt}.
			#-.
			{'accept (s)' translated.					#accept}.
			{'cancel (l)' translated.					#cancel}.
			#-.
			{'show bytecodes' translated.			#showBytecodes}.
			#-.
			{'copy html' translated.					#copyHtml}.
			#-.
			{'more...' translated.					#shiftedTextPaneMenuRequest}.
		}.
! !
