


!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/20/2010 20:24'!
aboutToBeGrabbedBy: aHand
	"Don't allow the receiver to act outside a Menu"

	(owner notNil and:[owner submorphs size = 1]) ifTrue:[
		"I am a lonely menuitem already; just grab my owner"
		owner stayUp: true.
		^owner aboutToBeGrabbedBy: aHand].
	^ self asMenu 

	! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/18/2009 18:13'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'add title...' translated action: #addTitle.
	aCustomMenu add: 'set target...' translated action: #setTarget:.
	defaultTarget ifNotNil: [
		aCustomMenu add: 'add item...' translated action: #addItem].
	aCustomMenu add: 'add line' translated action: #addLine.
	(self items count:[:any| any hasSubMenu]) > 0
		ifTrue:[aCustomMenu add: 'detach submenu' translated action: #detachSubMenu:].
		
	aCustomMenu addLine;
		add: 'detaching a submenu' translated target: self class selector: #howToDetach! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/20/2010 20:25'!
asMenu

	| menu |

	menu := MenuMorph new defaultTarget: nil.
	menu addMorphFront: self.
	menu bounds: self bounds.
	menu stayUp: true.
	
	menu thenAction: (self valueOfProperty: #then).
	menu defaultTarget: (self valueOfProperty: #target).
	self removeProperty: #then; removeProperty: #target.
	
	self isSelected: false.
	^menu! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/10/2010 15:18'!
detach

	self setProperty: #then toValue: owner thenAction.
	self setProperty: #target toValue: owner defaultTarget.
	(self hasProperty: #standAloneLabel) 
		ifTrue: [self contents: (self valueOfProperty: #standAloneLabel)].
	self delete; topLeft: ActiveHand position.
	ActiveHand grabMorph: self.
	self isSelected: false! !

!MenuMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 3/12/2012 15:19'!
detach

	self stayUp ifTrue: [^ self].

	popUpOwner ifNil: [^ self].

	ActiveHand submorphs ifNotEmpty: [^ self]. 

	popUpOwner isSelected: false.
	popUpOwner subMenu: nil. 
	popUpOwner owner activeSubmenu: nil.
	
	self addStayUpIcons.	
	(popUpOwner notNil & self hasTitle not) ifTrue: [self addTitle: popUpOwner contents].
	self popUpOwner: nil.
	self selectItem: nil event: nil.
	self stayUp: true.	
	
	self topLeft: ActiveHand position.
	ActiveHand grabMorph: self

		
! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/18/2009 18:13'!
detachExample

	| example subExample1 subSubExample subExample2 |

	example := MenuMorph new.
	
	(subExample1 := MenuMorph new)
		add: 'dummy' action: nil;
		add: 'void' action: nil.
	
	(subSubExample := MenuMorph new)
		add: 'nope' action: nil;
		add: 'nada' action: nil;
		add: 'niet' action: nil.
	
	(subExample2 := MenuMorph new)
		add: 'useless' action: nil;
		add: 'more of it' subMenu: subSubExample.
		
	example
		add: 'sub 1' subMenu: subExample1;
		add: 'sub 2' subMenu: subExample2;
		add: 'that''s it' action: nil.
		
	example popUpInWorld! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/18/2009 18:13'!
howToDetach

	'
	examples:
	
		MenuMorph detachExample "doIt for each example below"
	
	
	
	to detach the ''sub 1'' submenu, yellow click ''sub 1'' and drag to the right.
	to detach the ''sub 1'' item, blue click it twice and use the black halo.
	to detach ''that''s it'', yellow click it
	to detach the ''more of it'' submenu, yellow click ''more of it'' and drag to the right.
	to detach the ''more of it'' item, blue click it twice and use the black halo.
		
	' displayWithLabel: 'how to detach a submenu'! !

!MenuMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/10/2010 22:15'!
lastItemStandAloneLabel: aString

	self submorphs last setProperty: #standAloneLabel toValue: aString! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/31/2012 15:27'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	(Preferences enableMenuDestructuring & evt yellowButtonPressed & self hasSubMenu not and: [owner isSticky not])
		ifTrue: [self detach].

	(evt yellowButtonPressed not 
		and: [self actualSubMenu notNil] 
		and: [owner activeSubmenu == self actualSubMenu])
	ifTrue: [^ self deselect: evt].

	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt. 
! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/12/2010 17:27'!
mouseDown: evt
	"Handle a mouse down event."
	
	evt yellowButtonPressed ifTrue: [^ self].
	
	(stayUp or:[self fullContainsPoint: evt position]) 
		ifFalse:[^self deleteIfPopUp: evt]. "click outside"
	self isSticky ifTrue: [^self].
	"Grab the menu and drag it to some other place"
	evt hand grabMorph: self.! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/31/2012 15:26'!
mouseEnterDragging: evt
	"The mouse entered the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	(Preferences enableMenuDestructuring
		& evt yellowButtonPressed) ifTrue: [^ owner detach].
	
	((evt hand mouseFocus == owner)
		or: [owner popUpOwner notNil]
		or: [World submorphs noneSatisfy: [:m | 
				m isMenu and: [m popUpOwner notNil]]])
	ifTrue:[owner selectItem: self event: evt]! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/12/2010 22:07'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	evt hand mouseFocus == owner ifFalse:[^self].

	(self actualSubMenu notNil
		and: [owner activeSubmenu == self actualSubMenu]
		and: [owner stayUp]) ifTrue: [^ self].

	self contentString ifNotNil:[
		self contents: self contentString withMarkers: true inverse: true.
		self refreshWorld.
		(Delay forMilliseconds: 200) wait].
	self deselect: evt.
	self invokeWithEvent: evt.		
! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 4/19/2010 09:32'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem 
	"Present this menu at the given point under control of the given  
	hand."
	| delta tryToPlace selectedOffset |
	hand world startSteppingSubmorphsOf: self.
	popUpOwner := sourceItem.
	self fullBounds.
self updateColor.
	"ensure layout is current"
	selectedOffset := (selectedItem
				ifNil: [self items middle]) position - self position.
	tryToPlace := [:where :mustFit | 
			self position: where - selectedOffset.
			delta := self fullBoundsInWorld amountToTranslateWithin: sourceItem worldBounds.
			(delta x = 0
					or: [mustFit])
				ifTrue: [delta = (0 @ 0)
						ifFalse: [self position: self position + delta].
					"sourceItem owner owner" World addMorphFront: self.
					^ self]].
	tryToPlace value: rightOrLeftPoint first value: false;
		 value: rightOrLeftPoint last - (self width @ 0) value: false;
		 value: rightOrLeftPoint first value: true! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/12/2010 17:05'!
removeStayUpBox
	| box |
	submorphs isEmpty ifTrue: [^self].
	(submorphs first isAlignmentMorph) ifFalse: [^self].
	box := submorphs first submorphs last.
	(box isKindOf: IconicButton) 
		ifTrue: 
			[box delete]! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/17/2012 14:41'!
topOwnerMenu

	(owner popUpOwner ifNil: [^ owner]) topOwnerMenu! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/18/2009 18:13'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph.  A single-item MenuMorph is in effect a button rather than a menu, and as such should not be reluctant to be dropped into another object."

	^ (aMorph isWorldMorph or: [submorphs size == 1]) or:
		[Preferences systemWindowEmbedOK] or:
		[aMorph wantsDroppedMenu]
! !
