SystemOrganization addCategory: #PluggableMemory!


OrderedCollection subclass: #InteractionHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

FillInTheBlankMorph subclass: #MemoryInteractionMorph
	instanceVariableNames: 'memory dh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

TestCase subclass: #PluggableMemoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

InteractionHistory class
	instanceVariableNames: ''!

MemoryInteractionMorph class
	instanceVariableNames: ''!

BorderedMorph subclass: #WheelMorph
	instanceVariableNames: 'target actionSelector factor circular old angle maxAngle lastRedraw'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

WheelMorph class
	instanceVariableNames: ''!

LegacyTextMorphEditor subclass: #PluggableMemory
	instanceVariableNames: 'environment bindings history'
	classVariableNames: 'Memories'
	poolDictionaries: ''
	category: 'PluggableMemory'!

PluggableMemory class
	instanceVariableNames: ''!

PluggableMemoryTest class
	instanceVariableNames: ''!


!WheelMorph commentStamp: '<historical>' prior: 0!
A thumb wheel widget control!

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:56'!
actionSelector
	^ actionSelector
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:57'!
actionSelector: aSymbolOrString

	(nil = aSymbolOrString or:
	 ['nil' = aSymbolOrString or:
	 [aSymbolOrString isEmpty]])
		ifTrue: [^ actionSelector := nil].

	actionSelector := aSymbolOrString asSymbol.

! !

!WheelMorph methodsFor: 'private' stamp: 'ti 3/20/2000 15:58'!
addAngle: aNumber
	| new |
	new := self angle + aNumber.
	self isCircular ifTrue: [new := new \\ self maxAngle].
	self angle: new.
	lastRedraw := lastRedraw + aNumber.
	(lastRedraw abs > 2) ifTrue: [
		lastRedraw := 0.
		self changed]! !

!InteractionHistory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
addFirst: aString

	| entry |

	entry := aString withBlanksTrimmed.

	(self includes: entry) ifFalse: [^ super addFirst: entry].

	^ false! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 4/3/2010 18:09'!
addItemsToREPLMenu: aMenu

! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 4/3/2010 18:09'!
addItemsToREPLMenu: aMenu

	self environment addItemsToREPLMenu: aMenu
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:32'!
angle
	^angle! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:33'!
angle: aNumber
	angle := aNumber! !

!InteractionHistory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
atIndex: aNumber

	^ self at: (aNumber asInteger - 1 \\ self size) + 1! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:18'!
beCircular
	circular := true! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:34'!
beHorizontal
	self isHorizontal
		ifFalse: [self extent: self extent transposed] ! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
beLinear
	circular := false! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:34'!
beVertical
	self isHorizontal
		ifTrue: [self extent: self extent transposed] ! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2010 16:45'!
bindingOf: aString

	| b |

	b := [self environment bindingOf: aString] on: Error do: [nil].
	b ifNotNil: [^ b].

	(self bindings includesKey: aString)
		ifFalse: [self bindings at: aString put: nil].

	^ self bindings associationAt: aString! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
bindings

	^ bindings ifNil: [bindings := Dictionary new]! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 4/3/2010 18:44'!
bindings: aDictionary

	bindings := aDictionary ! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2010 16:49'!
compilationReceiver

	^ self isTransparent ifTrue: [self environment] ifFalse: [nil]
! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
compile: aString onErrorDo: aBlock

	^ (self changeParagraph: aString asParagraph) compileOrFailWith: aBlock! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2010 16:47'!
compileOrFailWith: aBlock

	^ Compiler new evaluate: paragraph string 
			in: "thisContext sender" nil 
			to: (self compilationReceiver)
			notifying: self 
			ifFail: aBlock logged: false.! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createBindingsButton

	"create the [accept] button"
	| result frame |
	result := SimpleButtonMorph new target: memory bindings;
				 color: Color lightGreen.
	result
		borderColor: (Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [result color twiceDarker]).
	result label: 'B' translated;
		 actionSelector: #explore.
	result setNameTo: 'bindings'.
	frame := LayoutFrame new.
	frame rightFraction: 1;
		 rightOffset: -2;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createHistoryButton

	"create the [accept] button"
	| result frame |
	result := SimpleButtonMorph new target: memory history;
				 color: Color lightGreen.
	result
		borderColor: (Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [result color twiceDarker]).
	result label: 'H' translated;
		 actionSelector: #explore.
	result setNameTo: 'history'.
	frame := LayoutFrame new.
	frame leftFraction: 0;
		 leftOffset: 2;
		 bottomFraction: 1.0;
		 bottomOffset: -2.
	result layoutFrame: frame.
	self addMorph: result.
	self
		updateColor: result
		color: result color
		intensity: 2.
	^ result! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createHistoryWheel

	| result frame |
	result := WheelMorph new beVertical.
	result extent: 20 @ 65.

	result target: self; actionSelector: #scrollHistoryBy:; factor: 0.2.

	frame := LayoutFrame new.
	frame topFraction: 0.15;
		leftFraction: 0.9;
		 rightFraction: 1;
"		 rightOffset: -2;"
		 bottomFraction: 0.75.
	result layoutFrame: frame.
	self addMorph: result.

	^ result! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean topOffset: topOffset buttonAreaHeight: buttonAreaHeight 
	"create the textPane"
	| result frame |
	result := PluggableTextMorph
				on: self
				text: #response
				accept: #response:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:.
	result extent: answerExtent.
	result hResizing: #spaceFill;
		 vResizing: #spaceFill.
	result borderWidth: 1.
	result hasUnacceptedEdits: true.
	result acceptOnCR: acceptBoolean.
	result setNameTo: 'textPane'.
	frame := LayoutFrame new.
	frame leftFraction: 0.0;
		 rightFraction: 0.9;
		 topFraction: 0.0;
		 topOffset: topOffset;
		 bottomFraction: 1.0;
		 bottomOffset: buttonAreaHeight negated.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
dictionary

	^ Memories! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 17:03'!
doTargetAction: cursorPoint
	| new delta |
	self isHorizontal
		ifTrue: [new := cursorPoint x]
		ifFalse: [new := cursorPoint y].
	delta := new - old.
	delta isZero ifTrue: [^self].
	self addAngle: delta.
	(target ~~ nil and: [actionSelector ~~ nil]) ifTrue: [
		Cursor normal showWhile: [
			target perform: actionSelector withArguments: (Array with: (delta * self factor))]].
	old := new.
! !

!WheelMorph methodsFor: 'drawing' stamp: 'bf 3/24/2000 10:55'!
drawOn: aCanvas
	| interval delta frame x0 x1 y0 y1 deltaX deltaY  hilitColor shadowColor |
	super drawOn: aCanvas.		"border & background"
	borderColor isColor
		ifTrue: [hilitColor := shadowColor := borderColor]
		ifFalse: [hilitColor := color lighter lighter.
			shadowColor := color darker darker].
	frame := self innerBounds insetBy: 2.
	aCanvas frameAndFillRectangle: frame fillColor: color
		borderWidth: 1 topLeftColor: hilitColor bottomRightColor: shadowColor.
	frame := frame insetBy: (borderColor isColor ifTrue: [1] ifFalse: [2]).
	x0 := frame origin x.
	x1 := frame corner x.
	y0 := frame origin y.
	y1 := frame corner y.
	deltaX := (x1 - x0) / 2.
	deltaY := (y1 - y0) / 2.
	interval := 10.
	delta := self angle \\ interval.
	1 to: (self maxAngle / (2 * interval)) rounded do: [ :i |
		| x y |
		self isHorizontal ifTrue: [
			x := x0 + deltaX - (((i * interval + delta) * (2 * Float pi / 360.0)) cos * deltaX).
			aCanvas fillRectangle: (Rectangle origin: (x-1)@y0 corner: x@y1) color: hilitColor.
			borderColor isColor ifFalse:
				 [aCanvas fillRectangle: (Rectangle origin: x@y0 corner: (x+1)@y1) color: shadowColor]]
		ifFalse: [
			y := y0 + deltaY - (((i * interval + delta) * (2 * Float pi / 360.0)) cos * deltaY).
			aCanvas fillRectangle: (Rectangle origin: x0@(y-1) corner: x1@y) color: hilitColor.
			borderColor isColor ifFalse:
				 [aCanvas fillRectangle: (Rectangle origin: x0@y corner: x1@(y+1)) color: shadowColor]]]! !

!MemoryInteractionMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
editor: aPlugglableMemory

	^ self new memory:  aPlugglableMemory
! !

!TextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
editor: anObject
	editor := anObject! !

!TextMorphForEditView methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
editor: anObject

	(editor notNil and: [editor isPermanent]) ifTrue: [^ self].
	editor := anObject! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
environment

	^ environment first! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
environment: anObject

	environment := WeakArray with: anObject! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
environmentName

	^ self environment knownName ifNil: [self environment name]! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 4/2/2010 09:38'!
evalString: aString

	(self environment handlesEvalString) 
		ifTrue: [^ self environment evalString: aString].

	^ self compile: aString onErrorDo: ['evaluation error']! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 4/2/2010 09:19'!
evalString: aString notifying: requestor
	^ self evalString: aString! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
evalText: aText from: aPluggableTextMorph

	self evalString: aText asString.
	aPluggableTextMorph hasUnacceptedEdits: false.! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
evaluate: aString onError: aBlock

	^ (PluggableMemory for: self) compile: aString onErrorDo: aBlock! !

!WheelMorph class methodsFor: 'examples' stamp: 'ti 3/24/2000 17:33'!
example
	"See B3DSceneExplorerMorph>>initialize for usage."
	"WheelMorph example"

	B3DSceneExplorerMorph new openInWorld! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 17:02'!
factor
	^factor! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 17:03'!
factor: aFloat
	factor := aFloat! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 11/11/2010 21:31'!
for: anObject

	(Memories includesKey: anObject) ifTrue: [^ Memories at: anObject].
	
	^ Memories at: anObject 
		put: (self allInstances detect: [:pm | pm environment == anObject]
			ifNone: [self new environment: anObject])
! !

!PluggableTextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
getTextSelector: anObject
	getTextSelector := anObject! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
getUserResponse

	memory changeParagraph: textPane textMorph paragraph.
	memory morph: textPane textMorph.
	textPane textMorph editor: memory. 

	^ super getUserResponse

! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 4/2/2010 09:23'!
handlesEvalString

	"answer true if the receiver implements #evalString: and thus handles the evaluation process by itself, by passinf the Compiler"

	^ false
	! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 14:50'!
handlesMouseDown: evt
	^true
! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
hasPMBindingFor: anObject

	^ self hasPluggableMemory
		and: [self pluggableMemory bindings values identityIncludes: anObject]! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
hasPluggableMemory

	^ PluggableMemory dictionary includesKey: self! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
history

	^ history ifNil: [history := InteractionHistory new]! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
initialize

	"PluggableMemory initialize"

	Memories  := WeakKeyDictionary new.! !

!WheelMorph methodsFor: 'initialization' stamp: 'HilaireFernandes 1/27/2008 10:22'!
initialize
	super initialize.
	self target: nil.
	self actionSelector: #flash.
	self angle: 0.
	self maxAngle: 360.
	self factor: 1.0.
	self extent: 100@23.
	self beCircular.
	self borderColor: #raised.
	self borderWidth: 1.
	self color: Color lightGray.
	lastRedraw := 0.! !

!TextMorph methodsFor: '*PluggableMemory-override' stamp: 'spfa 11/18/2009 18:17'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	self editor: (self editorClass new morph: self).
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
isCircular
	^circular! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:26'!
isHorizontal
	^ bounds isWide! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
isLinear
	^circular not! !

!ParagraphEditor methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
isPermanent

	^ false! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
isPermanent

	^ true! !

!SmalltalkEditor methodsFor: '*PluggableMemory' stamp: 'spfa 4/15/2010 20:34'!
isPermanent

	^ false! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2010 17:01'!
isTransparent

	^ self environment wantsTransparentPM! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/22/2000 19:12'!
isVertical
	^self isHorizontal not! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:35'!
maxAngle
	^maxAngle! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:35'!
maxAngle: aNumber
	maxAngle := aNumber! !

!MemoryInteractionMorph methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
memory: anObject
	memory := anObject! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/14/2000 18:09'!
mouseDown: evt
	self isHorizontal
		ifTrue: [old := evt cursorPoint x]
		ifFalse: [old := evt cursorPoint y].! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 14:51'!
mouseMove: evt
	(evt anyButtonPressed)
		ifTrue: [self doTargetAction: evt cursorPoint]! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
openInteractionNotebook

	(PluggableMemory for: self) openInteractionNotebook! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
openInteractionNotebook

	((Notebook on: self) 
		inSystemWindowLabelled: 'interaction with ', self environmentName)
	openInWorld! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
openInteractionWindow

	(PluggableMemory for: self) openInteractionWindow! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
openInteractionWindow

	| w |

	w := SystemWindow labelled: 'interaction with ', self environmentName.
	w paneColor: Color greenYellow darker.
	w addMorph: (REPLMorph on: self) frame: (0@0 corner: 1@1).
	w openInWorld! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
outputStream

	"dummy"

	^ WriteStream on: ''! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
paragraph

	^ paragraph! !

!TextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
paragraph: anObject
	paragraph := anObject! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
pluggableMemory

	(PluggableMemory dictionary includesKey: self)
		ifTrue: [^ PluggableMemory for: self].

	^ nil! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/29/2011 14:12'!
prompt

	^ '>'! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
query: qString proposed: pString onCancelDo: cBlock onErrorDo: aBlock

	| aFillInTheBlankMorph |

	aFillInTheBlankMorph := (MemoryInteractionMorph editor: self)
		setQuery: qString
		initialAnswer: pString
		answerExtent: FillInTheBlankMorph defaultAnswerExtent
		acceptOnCR: false.
	aFillInTheBlankMorph responseUponCancel: nil.
	World addMorph: aFillInTheBlankMorph centeredNear: Display center.

	^ aFillInTheBlankMorph getUserResponse.
! !

!TextMorph methodsFor: '*PluggableMemory-override' stamp: 'spfa 11/18/2009 18:17'!
releaseEditor 
	"Release the editor for my paragraph.  This morph no longer 'hasFocus'."
	editor ifNotNil:
		[self selectionChanged.
		self paragraph selectionStart: nil selectionStop: nil.
		self editor: nil].! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
response: aText
	"Sent when text pane accepts."

	memory history addFirst: aText string.
	response := textPane textMorph editor compileOrFailWith: [^ false].
	textPane getTextSelector: #name. "dummy"
	done := true.
	^ true

! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/31/2011 12:21'!
scrollHistoryBy: aNumber

	| newText |

	dh := (dh ifNil: [0])+ aNumber.
	dh abs > 1 ifFalse: [^ self].
	memory history ifEmpty: [^ self].

	newText := memory history atIndex: dh.

"	textPane setText: newText."
	memory selectAll.
	memory zapSelectionWith: newText.
	textPane setText: memory paragraph text.
	memory morph: textPane textMorph.
	textPane textMorph editor: memory. 
	textPane hasUnacceptedEdits: true.

! !

!PluggableMemory methodsFor: 'hack' stamp: 'spfa 3/31/2011 12:43'!
selectFrom: start to: stop
	"Select the specified characters inclusive."
	self selectInvisiblyFrom: start to: stop.! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	| query topOffset accept cancel buttonAreaHeight |
	response := initialAnswer.
	done := false.
	self removeAllMorphs.
	self layoutPolicy: ProportionalLayout new.
	query := self createQueryTextMorph: queryString.
	topOffset := query height + 4.
	accept := self createAcceptButton.
	cancel := self createCancelButton.

	self createBindingsButton.
	self createHistoryButton.
	self createHistoryWheel.

	buttonAreaHeight := (accept height max: cancel height)
				+ 4.
	textPane := self
				createTextPaneExtent: answerExtent
				acceptBoolean: acceptBoolean
				topOffset: topOffset
				buttonAreaHeight: buttonAreaHeight.
	self extent: (query extent x max: answerExtent x)
			+ 4 @ (topOffset + answerExtent y + 4 + buttonAreaHeight).
	! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:47'!
target
	^target! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:48'!
target: aTargetObject
	target := aTargetObject! !

!PluggableMemoryTest methodsFor: 'as yet unclassified' stamp: 'spfa 12/21/2012 18:22'!
testEvaluate

	| o |

	o := Dictionary new.

	self assert: (o evaluate: 'self' onError: [nil]) == o.
	self assert: (o evaluate: 'self class' onError: [nil]) == Dictionary.

	o evaluate: 'yo := 42' onError: [nil].
	self assert: (o evaluate: '10 * yo' onError: [nil]) = 420.

	self assert: o pluggableMemory history isEmpty! !

!PluggableTextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
textMorph
	^textMorph! !

!PluggableMemory methodsFor: 'hack' stamp: 'spfa 11/18/2009 18:15'!
userHasEdited! !

!Morph methodsFor: '*PluggableMemory' stamp: 'spfa 11/7/2010 17:02'!
wantsTransparentPM

	^ (self valueOfProperty: #transparentPluggableMemory) ~~ false! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/7/2010 17:00'!
wantsTransparentPM

	^ true! !
PluggableMemory initialize!
