'From Squeak4.1 of 17 April 2010 [latest update: #9956] on 13 August 2010 at 2:51:57 am'!

!MenuItemMorph methodsFor: 'events' stamp: 'spfa 4/15/2010 21:23'!
releasesSelection: evt
	" Returns a boolean indicating that this menu item is ready to go deselected.
	It answers false if the mouse is moving towards its submenu. 
	We check this by testing that the current mouse position lays in the triangle of 
	the last mouse position and the two corners of the submenu facing our menu item. "

	| triangle submenuIsOnTheRightSide |
	self hasSubMenu ifFalse: [ 
		lastMousePosition := nil.
		^true ].
	lastMousePosition ifNil: [ 
		lastMousePosition := evt position.
		^false ].
	submenuIsOnTheRightSide := self left < self subMenu left.
	triangle := {
		lastMousePosition.
		submenuIsOnTheRightSide 
			ifTrue: [ self subMenu topLeft ] 
			ifFalse: [ self subMenu topRight ].
		submenuIsOnTheRightSide 
			ifTrue: [ self subMenu bottomLeft ] 
			ifFalse: [ self subMenu bottomRight ] }.
	lastMousePosition := evt position.
	(self triangle: triangle containsPoint: evt position)
		ifTrue: [ ^false ]
		ifFalse: [ 
			lastMousePosition := nil.
			^true ]! !

!MenuItemMorph methodsFor: 'selecting' stamp: 'spfa 4/15/2010 21:12'!
deselect: evt
	self isSelected: false.
	lastMousePosition := nil.
	self subMenu ifNotNil: [
		owner ifNotNil:[owner activeSubmenu: nil. self deleteSubMenu].
		self removeAlarm: #deselectTimeOut:].! !

!MenuItemMorph methodsFor: 'selecting' stamp: 'kb 11/21/2009 09:20'!
mouseLeaveDragging: evt 
	"The mouse left the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	owner ifNil: [^self].
	evt hand mouseFocus == owner ifFalse: [ ^self ].
	lastMousePosition := evt position.
	owner selectItem: nil event: evt! !

!MenuItemMorph methodsFor: 'private' stamp: 'spfa 4/15/2010 21:20'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied  
	at all, but shared. Warning!!!! Every instance variable defined in  
	this class must be handled. We must also implement  
	veryDeepFixupWith:. See DeepCopier class comment."
	super veryDeepInner: deepCopier.
	isEnabled := isEnabled veryDeepCopyWith: deepCopier.
	subMenu := subMenu veryDeepCopyWith: deepCopier.
	isSelected := isSelected veryDeepCopyWith: deepCopier.
	icon := icon veryDeepCopyWith: deepCopier.
	"target := target.		Weakly copied"
	"selector := selector.		a Symbol"
	arguments := arguments veryDeepCopyWith: deepCopier.
	lastMousePosition := nil! !

