SystemOrganization addCategory: #'People-spfa-utils'!
SystemOrganization addCategory: #'People-spfa-utils-for-menu'!
SystemOrganization addCategory: #'People-spfa-utils-base1'!


Morph subclass: #VanishingMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

BorderedMorph subclass: #MouseInputArea
	instanceVariableNames: 'balloonText messageSend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea class
	instanceVariableNames: ''!

MouseInputArea subclass: #SensitiveArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea subclass: #DropReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

DropReporter subclass: #MIDIFileDumperMorph
	instanceVariableNames: 'directory lastFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

DropReporter subclass: #TransferGetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

SensitiveArea class
	instanceVariableNames: ''!

TextMorph subclass: #UpdatingTextMorph
	instanceVariableNames: 'target getSelector growable stepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils-base1'!

UpdatingTextMorph class
	instanceVariableNames: ''!

DropReporter subclass: #InteractiveMorphOperator
	instanceVariableNames: 'lms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

UpdatingTextMorph subclass: #MPEGSubtitlesDisplayer
	instanceVariableNames: 'font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils-base1'!

MPEGSubtitlesDisplayer class
	instanceVariableNames: ''!

SimpleButtonMorph subclass: #StrongButtonMorph
	instanceVariableNames: 'inactiveColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

StrongButtonMorph class
	instanceVariableNames: ''!

VanishingMorph class
	instanceVariableNames: ''!

MenuItemMorph subclass: #MenuSliderItemMorph
	instanceVariableNames: ''
	classVariableNames: 'MenuSliderColor'
	poolDictionaries: ''
	category: 'People-spfa-utils-for-menu'!

MenuSliderItemMorph class
	instanceVariableNames: ''!

DropReporter class
	instanceVariableNames: ''!

MIDIFileDumperMorph class
	instanceVariableNames: ''!

TransferGetter class
	instanceVariableNames: ''!

InteractiveMorphOperator class
	instanceVariableNames: ''!

SharedQueue subclass: #LimitedSharedQueue
	instanceVariableNames: 'maxSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

LimitedSharedQueue class
	instanceVariableNames: ''!


!DropReporter commentStamp: '<historical>' prior: 0!
usage:

	(DropReporter sendMorphTo: receiver via: selector) openInWorld

any morph dropped in the DropReporter is sent to receiver via selector, then the morph is rejected to its previous position and the DropReporter disappear (to make it permanent, double-click inside: the border becomes green, and more than one morph can be dropped).

receiver can be nil, in which case selector is sent to the morph itself.

examples:

	(DropReporter sendMorphTo: nil via: #collapse) openInWorld

	(DropReporter sendMorphTo: (Lambda m color: Color red) via: #value:) openInWorld

	(DropReporter sendMorphTo: [:m | m explore] via: #value:) openInWorld!

!MIDIFileDumperMorph commentStamp: 'spfa 1/26/2010 23:57' prior: 0!
Provide an handy way to write MIDI files in a given directory.!

!MouseInputArea commentStamp: 'spfa 3/11/2004 09:35' prior: 0!
A labelled rectangular area triggering a MessageSend upon specific mouse activity.

The area may disappear after action (it is not "permanent") or even disappear after a few seconds whatever happens (it is then "temporary")

This abstract class does not implement event handling. See subclasses.

!

!SensitiveArea commentStamp: 'spfa 3/11/2004 09:58' prior: 0!
This area evaluate its MessageSend upon mouseEnter!

!UpdatingTextMorph commentStamp: 'asm 7/31/2003 21:27' prior: 0!
A TextMorph that constantly tries to show the current data from the target object.  When sent #step, it shows what the target objects has (target perform: getSelector).!

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/13/2010 15:36'!
-\\+ aNumber

	"modulo with floor 1 (useful for indexation). 
	see #atWrap:
	"

	^ self - 1 \\ aNumber + 1

	! !

!Collection methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/3/2011 10:49'!
/// arg

	^ arg adaptToCollection: self andSend: #///! !

!Float methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 7/17/2012 19:55'!
/// aNumber

	^ self / aNumber! !

!Number methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 11/19/2009 13:31'!
/// aNumber

	"always return a Float or a SmallInteger. useful since a Fraction behaves much slower than a Float in most computations "

	^ self / aNumber asFloat! !

!Point methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 11/18/2009 18:15'!
/// arg 
	"Answer a Point that is the quotient of the receiver and arg."

	arg isPoint ifTrue: [^ (x /// arg x) @ (y /// arg y)].
	^ arg adaptToPoint: self andSend: #///! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/13/2010 15:30'!
\\+ aNumber

	"modulo offset by 1 (useful for indexation)"

	^ self \\ aNumber + 1

	! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:09'!
acceptDroppingMorph: dropee event: evt 

	| ms |

	dropee wasReported.
	dropee rejectDropMorphEvent: evt.
	dropee wasRejected.

	ms := messageSend.
	ms receiver ifNil: [ms receiver: dropee].

	(ms valueWithArguments: {dropee})
		ifNil: [^ self]. 	"if receiver sent nil back, it didn't like the dropee. so stay alive and wait for the next one"

	(self hasProperty: #permanent)
		ifFalse: [self delete]! !

!TransferGetter methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:17'!
acceptDroppingMorph: dropee event: evt 

	| ms passenger |

	passenger := dropee passenger.

	ms := messageSend.
	ms receiver ifNil: [ms receiver: passenger].

	(ms valueWithArguments: {passenger})
		ifNil: [^ self]. 	"if receiver sent nil back, it didn't like the dropee. so stay alive and wait for the next one"

	(self hasProperty: #permanent)
		ifFalse: [self delete]! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
accumulatedRuns

	| d |

	d := 0.

	^ runs collect: [:r | d := d + r]! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
accumulatedRunsAndValuesDo: aBlock

	^ self accumulatedRuns with: values do: aBlock.! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/12/2010 22:19'!
activateSubmenu: evt
	"Activate our submenu; e.g., pass control to it"

	(self subMenu ifNil: [^false]) activate: evt.
	^true! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/9/2010 00:22'!
activeSubmenu
	^ activeSubMenu ! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
actualSubMenu

	^ self valueOfProperty: #actualSubMenu! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
actualSubMenu: aMenuMorph

	self setProperty: #actualSubMenu toValue: aMenuMorph! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
adaptToComplex: rcvr andSend: selector
	"If I am involved in arithmetic with a Complex number, convert me to a Complex number."
	^ rcvr perform: selector with: self asComplex! !

!Complex methodsFor: '*People-spfa-utils' stamp: 'spfa 4/1/2012 11:02'!
adaptToPoint: rcvr andSend: selector
	"If I am involved in arithmetic with a Fraction, convert it to a Complex number."
	^ (rcvr asComplex perform: selector with: self) asPoint! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/26/2010 13:49'!
add: aString action: aSelector argumentSubMenu: anArray 

	self
		add: aString
		subMenu: (MenuMorph lambda onList: anArray 
						build: [:key | defaultTarget lambda: aSelector with: key])! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/23/2010 11:24'!
add: aString dropToSetter: setter then: last

	| lambdaSetter lastLambda |

	lambdaSetter := self makeLambdaFrom: setter.
	lastLambda := self makeLambdaFrom: last.

	self add: aString
		 target: self
		 selector: #deliverMorphicArgumentFor:withString:initialAnswer:thenDo:
		 argumentList: {lambdaSetter . aString . '' . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString dynamicSubMenu: aSymbolOrLambda
	"Append the given submenu with the given label."

	| ms |

	ms := aSymbolOrLambda.
	ms isSymbol ifTrue: 
		[ms := MessageSend receiver: defaultTarget selector: aSymbolOrLambda].

	self
		add: aString
		subMenu: ms asLambdaMessageSend! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString forkAction: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the default target object in a separate thread."

	self add: aString
		target: (MessageSend receiver: defaultTarget selector: aSymbol)
		selector: #fork
		argumentList: EmptyArray.! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: getter dropToSetter: setter then: last

	| lambdaGetter lambdaSetter lastLambda |

	lambdaGetter := self makeLambdaFrom: getter.
	lambdaSetter := self makeLambdaFrom: setter.
	lastLambda := self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #deliverMorphicArgumentFor:withString:initialAnswer:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: getter dropToSetter: setter withDependents: anArray then: last

	| lambdaGetter lambdaSetter lastLambda |

	lambdaGetter := self makeLambdaFrom: getter.
	lambdaSetter := self makeLambdaFrom: setter.
	lastLambda := self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #deliverMorphicArgumentFor:withString:initialAnswer:morphDependents:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . anArray . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector

	self add: aString getter: aSelector lambdaSetter: bSelector target: defaultTarget! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString 

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: defaultTarget then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject then: cSelector

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> (anObject lambda: aSelector)))
	 target: self
	 selector: #lambdaParseArgumentFor:inBehalfOf:withString:initialAnswer:then:
	 argumentList: {bSelector . anObject . qString . aSelector . cSelector}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector target: anObject

	self add: aString getter: aSelector lambdaSetter: bSelector target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector target: anObject then: cSelector

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: aString target: anObject then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector lambdaSetter: bSelector then: cSelector

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: aString target: defaultTarget then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector

	self add: aString getter: aSelector setter: bSelector target: defaultTarget! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/22/2010 22:43'!
add: aString getter: getter setter: setter morphDrive: lambdaSlotType morphAddDependents: anArray then: last

	| lambdaGetter lambdaSetter lastLambda mLambda |

	lambdaGetter := self makeLambdaFrom: getter.
	lambdaSetter := self makeLambdaFrom: setter.
	mLambda :=  (Lambda morph defaultGetterForLambdaSlotType: lambdaSlotType).
	lastLambda := self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #queryMorphicArgumentFor:withString:initialAnswer:initialMorphicLambda:morphDependents:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . mLambda . anArray  . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString 

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: defaultTarget then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: cSelector

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> (anObject lambda: aSelector)))
		 target: self
		 selector: #queryArgumentFor:inBehalfOf:withString:initialAnswer:then:
		 argumentList: {bSelector . anObject . qString . aSelector . cSelector}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector target: anObject

	self add: aString getter: aSelector setter: bSelector target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector target: anObject then: cSelector

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: aString target: anObject then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: aSelector setter: bSelector then: cSelector

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: aString target: defaultTarget then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: gSymbol setter: aSymbol withIntSlider: anInterval

	^ self 
		add: aString getter: gSymbol setter: aSymbol;
		addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol truncate: true
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString getter: gSymbol setter: aSymbol withSlider: anInterval

	^ self 
		add: aString getter: gSymbol setter: aSymbol;
		addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString lambda: aLambdaMessageSend

	self add: aString target: aLambdaMessageSend action: #value! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString selector: aSymbol argumentList: arg

	self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: arg
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/1/2011 13:35'!
add: aString settingProperty: aSymbol of: aMorph

	self add: aString settingProperty: aSymbol of: aMorph then: #yourself
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/1/2011 13:37'!
add: aString settingProperty: aSymbol of: aMorph then: bSymbol

	self addUpdatingLambda: ((aString, ': %s') lambda sformat: (aMorph lambda valueOfProperty:  aSymbol)) 
	 target: self
	 selector: #lambdaParseArgumentFor:inBehalfOf:withString:initialAnswer:then:
	 argumentList: {
		#value: . 
		aMorph lambda setProperty: aSymbol toValue: Lambda o .
		aString . 
		'' . 
		bSymbol}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString toggleForProperty: aSymbol
	
	self add: aString toggleForProperty: aSymbol target: defaultTarget
			  				  ! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString toggleForProperty: aSymbol target: aMorph
	
	self addUpdatingLambda: ((aMorph lambda hasProperty: aSymbol) yesNoString, aString)
		  target: aMorph
		  selector: #toggleProperty: 
		  argumentList: {aSymbol}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString toggleForProperty: aSymbol then: bSymbol

	self add: aString 
		toggleForProperty: aSymbol 
		then: bSymbol 
		target:  defaultTarget
			  				  ! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString toggleForProperty: aSymbol then: bSymbol target: aMorph

	self addUpdatingLambda:
			((aMorph lambda hasProperty: aSymbol) yesNoString, aString)
		  target: aMorph
		  selector: #toggleProperty:then:
		  argumentList: {aSymbol . bSymbol}.! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aListOfAssociations valuesForProperty: aSymbol 

	^ self add: aListOfAssociations valuesForProperty: aSymbol then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/21/2010 17:11'!
add: aListOfAssociations valuesForProperty: aSymbol target: aMorph

	^ self add: aListOfAssociations valuesForProperty: aSymbol 
		target: aMorph then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/21/2010 17:12'!
add: aListOfAssociations valuesForProperty: aSymbol target: aMorph then: bSymbol

	aListOfAssociations do: [:ea |
	self addUpdatingLambda: 
			(((aMorph lambda valueOfProperty: aSymbol) quoted = ea value)
 				yesNoString, ea key)
		target: aMorph
		selector: #setProperty:toValue:then: 
		argumentList: {aSymbol . ea value . bSymbol}	]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aListOfAssociations valuesForProperty: aSymbol then: bSymbol

	aListOfAssociations do: [:ea |
	self addUpdatingLambda: 
			(((defaultTarget lambda valueOfProperty: aSymbol) quoted = ea value)
 				yesNoString, ea key)
		target: defaultTarget
		selector: #setProperty:toValue:then: 
		argumentList: {aSymbol . ea value . bSymbol}	]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString watchingBoolean: aMessageSend selector: sSymbol argument: arg
	
	self add: aString watchingBoolean: aMessageSend target: defaultTarget selector: sSymbol argumentList: {arg}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
add: aString watchingBoolean: aLambdaBoolean target: anObject selector: sSymbol argumentList: anArray
	
	self addUpdatingLambda: (aLambdaBoolean yesNoString, aString)
		  target: anObject
		  selector: sSymbol 
		  argumentList: anArray! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/13/2010 17:14'!
addChoice: aList getter: gSymbol setter: sSymbol

	self addLabelledChoice: (aList collect: [:k | k -> k]) getter: gSymbol setter: sSymbol

	
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/25/2012 10:01'!
addChoice: aList getter: gSymbol setter: sSymbol target: anObject

	self addLabelledChoice: (aList collect: [:k | k -> k]) 
		getter: gSymbol setter: sSymbol target: anObject

	
! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
addCloseBox
	
	(labelArea isNil or: [self wantsCloseBox])
		ifTrue: [^ super addCloseBox].
	
	closeBox := (BorderedMorph new) color: Color transparent; extent: 0@0.
	labelArea addMorph: closeBox! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addFastUpdatingLabel: aString watching: aLambda

	(self 
	addUpdating: #value 
	target: (aString lambda, aLambda quoted withMenuPrecision quoted asString)
	selector: #ignore 
	argumentList: #()) getProperty: #fast
	! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
addFirstItems: anArray

	self addFirstLabels: (anArray inject: '' into: [:string :spec | 
		string, String cr, spec first]) allButFirst.
	self addFirstSelections: (anArray collect: [:spec | spec second])! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
addFirstLabels: aString

	| offset |

	offset := (aString occurrencesOf: Character cr) + 1.

	lineArray := {offset}, (lineArray collect: [:i | i + offset]).
	labelString := aString, String cr, labelString! !

!SelectionMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
addFirstSelections: anArray

	selections := anArray, selections! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/6/2013 10:11'!
addFlushLeftSubTitle: aString

	self addSubTitle: aString updatingSelector: nil updateTarget: nil.
	self submorphs last wrapCentering: #topLeft.! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2011 12:24'!
addHaloHW: aNumber
	| halo prospectiveHaloClass |
	prospectiveHaloClass := Smalltalk at: self haloClass ifAbsent: [HaloMorph].
	halo := prospectiveHaloClass new bounds: self worldBoundsForHalo.
	halo setProperty: #handleSize toValue: aNumber.
	halo popUpFor: self event: nil.
	^halo! !

!Project class methodsFor: '*People-spfa-utils' stamp: 'tk 9/22/1999 18:45'!
addItem: item toMenu: menu selection: action project: aProject
	| aColor |
	aColor := aProject isMorphic 
		ifTrue: [aProject world isInMemory 
			ifTrue: [Color red darker] 
			ifFalse: [Color brown]]
		ifFalse: [aProject world isInMemory 
			ifTrue: [Color veryVeryDarkGray]
			ifFalse: [Color blue]].
	(menu isKindOf: MenuMorph)
		ifTrue:
			[menu add: item selector: #jumpToSelection: argument: action.
			menu items last color: aColor]
		ifFalse:
			[menu add: item action: action]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addLabel: aString

	self add: aString asString target: nil selector: #isNil! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/13/2010 17:13'!
addLabelledChoice: aList getter: gSymbol setter: sSymbol

	aList do: [:assoc |
		self add: assoc key asString
			watchingBoolean: 
				((defaultTarget lambda: gSymbol) lambda: #== with: assoc value)
	 		selector: sSymbol 
			argument: assoc value]
	
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/25/2012 09:59'!
addLabelledChoice: aList getter: gSymbol setter: sSymbol target: anObject

	aList do: [:assoc |
		self add: assoc key asString
			watchingBoolean: 
				((anObject lambda: gSymbol) lambda: #== with: assoc value)
			target: anObject
	 		selector: sSymbol 
			argumentList: {assoc value}]
	
! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
addLabels: aString

	lineArray := lineArray, {self nItems}.
	labelString := labelString, String cr, aString.! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/28/2010 16:14'!
addMenu

	| menu |

	menu := self menu stayUp: true; beSticky.
	menu color: Color transparent; borderColor: Color transparent.
	self addMorph: menu.
	menu topLeft: self topLeft + (5 @ 5)! !

!SystemWindow methodsFor: '*People-spfa-utils' stamp: 'spfa 5/22/2013 11:54'!
addMorph: aMorph unchangedFullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.
	paneMorphs := paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	aMorph adoptPaneColor: self paneColor.
	aMorph borderWidth: 1; borderColor: Color lightGray; color: Color white.
	self addPaneSplitters! !

!SelectionMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
addSelections: anArray

	selections := selections, anArray! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addService: aService

	self addService: aService for: nil! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addServices: aListOfServices

	aListOfServices do: [:service | self addService: service]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addSlider: anInterval getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addSlider: anInterval label: aString getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol truncate: false

! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 6/18/2013 23:19'!
addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol truncate: aBoolean

	| item slider |
	slider := (SimpleSliderMorph new target: target;
				 actionSelector: aSymbol;
				 truncate: aBoolean;
				 minVal: anInterval start;
				 maxVal: anInterval end;
				 adjustToValue: (target perform: gSymbol);
				 color: MenuSliderItemMorph menuSliderColor;
				 sliderColor: MenuSliderItemMorph menuSliderColor darker;
				 extent: ((anInterval extent max: 150) min: 200) @ 10).
	item := MenuSliderItemMorph new contents: aString.
	self addMorphBack: item.
	item addMorph: slider.
	^ item
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addSlider: anInterval target: target getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: ' ' target: target getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 6/18/2013 14:20'!
addSlider: anInterval target: target getter: gSymbol setter: aSymbol truncate: aBoolean

	^ self addSlider: anInterval label: '' target: target getter: gSymbol setter: aSymbol truncate: aBoolean
! !

!Morph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/18/2009 18:13'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu addLine].

	aMenu 	
		add: 'send to project...' translated action: #sendToAnotherProject;
		add: 'copy to project...' translated action: #copyToAnotherProject;
		addLine.

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	self addHaloActionsTo: aMenu.
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addPlayerItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.
	self addStackItemsTo: aMenu.
	self addMiscExtrasTo: aMenu.
	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables := self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: unlockables first externalName)
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/31/2012 15:41'!
addSubTitle: aString
	"Add a title line to this menu."

	self addSubTitle: aString updatingSelector: nil updateTarget: nil! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/31/2012 15:43'!
addSubTitle: aString updatingSelector: aSelector updateTarget: aTarget 
	"Add a title line to this menu
	 Make aString its initial  contents.  
	If aSelector is not nil, then periodically obtain fresh values for  
	its  
	contents by sending aSelector to aTarget.."
	| title |
	title := AlignmentMorph newColumn.
	self setTitleParametersFor: title.
	aSelector
		ifNil: [""
			aString asString
				linesDo: [:line | title
					addMorphBack: ((StringMorph 
										contents: line 
										font: Preferences standardMenuFont)
										color: (Color black);
										yourself)]]
		ifNotNil: [| usm | 
			usm := UpdatingStringMorph on: aTarget selector: aSelector.
			usm font: Preferences standardMenuFont.
			usm useStringFormat.
			usm lock.
			title addMorphBack: usm].
	""
	title setProperty: #titleString toValue: aString.
	self addMorphBack: title.
	""
	title useSquareCorners! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addSubclassesOf: aMorphClass

"
	add an item for registered subclasses of aMorphClass, allowing to open an instance in Hand.

	the registration is done on the class side through:
	#idString	-> when not nil (a String), make an item with that label
	#instanceTypes  -> when not-nil (a Dictionary), make a submenu with keys as labels and values as nativity selectors
	#partsBinSubmenuHeader -> when present (returns a String) make a submenu for all subclasses. 
"

	aMorphClass subclasses do: [:ea |

	(ea idString notNil 
		and: [(ea class includesSelector: #partsBinSubmenuHeader) not])
	ifTrue: 
	[
		| itypes |
		(itypes := ea instanceTypes)
		ifNil: [self add: (ea idString) 
						 target: ea 
						 selector: #asNewMorphInHand]
		ifNotNil: [self add: (ea idString, ' ') subMenu: (ea instanceTypesMenu)].
		self addSubclassesOf: ea
	]
	ifFalse:
	[
		(ea class includesSelector: #partsBinSubmenuHeader) 
	 	ifTrue: 
	 	[
			ea partsBinSubmenuHeader
			ifNotNil: [	| m |
						m := MenuMorph new.
						ea idString 
						ifNotNil: [m add: (ea idString) 
									 target: ea 
						 			 selector: #asNewMorphInHand].
  		 				m addSubclassesOf: ea.
						self add: (ea partsBinSubmenuHeader, ' ') subMenu: m]
		]
		ifFalse: [self addSubclassesOf: ea]
	]]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addToggleForProperty: aSymbol

	self add: aSymbol asString toggleForProperty: aSymbol! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addUpdatingLabel: aString watching: aLambda

	self 
	addUpdating: #value 
	target: (aString lambda, aLambda quoted withMenuPrecision quoted asString)
	selector: #ignore 
	argumentList: #()
	! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addUpdatingLabel: aString watching: aLambdaExpression action: aSelector

	self addUpdatingLabel: aString watching: aLambdaExpression action: aSelector target: defaultTarget
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addUpdatingLabel: aString watching: aLambdaExpression action: aSelector target: anObject

	self addUpdatingLambda: 
			(aString lambda sformat: aLambdaExpression) 
		target: anObject
		selector: aSelector
		argumentList: #()! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
addUpdatingLambda: wordingLambda target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by evaluating the wordingLambda (a MessageSend or LambdaMessageSend). Answer the item added."

	| item |
	item := UpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: wordingLambda wordingSelector: #value;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 9/2/2012 22:54'!
afterObject: target ifAbsent: exceptionBlock
	"Answer the element after target.  Answer the result of evaluation
	the exceptionBlock if target is not in the receiver, or if there are 
	no elements after it."

	| index |
	index := self identityIndexOf: target.
	^ (index == 0 or: [index = self size])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index + 1]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
allButFirstAndLast

	^ self copyFrom: 2 to: self size - 1! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
allFontsBecome: aFont

	self allMorphsDo: [:m |
		(m respondsTo: #font:) 
			ifTrue: [m font: aFont]].

	self changed
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
allFontsToDefault

	self allFontsBecome: TextStyle defaultFont.
	self changed

! !

!Process class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
allNamed: aString

	^ self allInstances select: [:p | p name = aString]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 3/26/2010 11:37'!
allSynonymsOfAll: aCollection

	| s |

	s := IdentitySet new.
	aCollection do: [:symb |
		s addAll: (self synonymsOf: symb)].
	^ s
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
allWordingsNotInSubMenus: verbotenSubmenuContentsList
	"Answer a collection of the wordings of all items and subitems, but omit the stay-up item, and also any items in any submenu whose tag is in verbotenSubmenuContentsList"

	self isStayUpItem ifTrue:[^ #()].
	self subMenu ifNotNil:
		[^ (verbotenSubmenuContentsList includes: self contents asString)
			ifTrue:
				[#()]
			ifFalse:
				[self subMenu allWordingsNotInSubMenus: verbotenSubmenuContentsList]].

	^ Array with: self contents asString! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
analyseDifferenceAfter: aBlock 

	self analyseDifferenceAfter: aBlock forClasses: Smalltalk allClasses.
! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
analyseDifferenceAfter: aBlock forClasses: classes

	| before after |

	before := SpaceTally new preAllocateResultsFor: classes.
	after := SpaceTally new preAllocateResultsFor: classes.
	Smalltalk garbageCollect.
	before computeSpaceUsageWithProgress:  'first pass...'.
	aBlock value.
	Smalltalk garbageCollect.
	after computeSpaceUsageWithProgress: 'second pass...'.
	SpaceTally compare: before to: after ! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
asAnchoredText

	^ (Character value: 1) asText 
		addAttribute: (TextAnchor new anchoredMorph: self) from: 1 to: 1;
		addAttribute: (TextColor color: Color transparent) from: 1 to: 1.! !

!Float methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 11/15/2011 15:42'!
asApproximateFractionWithDenominatorAtMost: maxDenominator

	| num1 denom1 num2 denom2 int frac newD temp |
	num1 := self asInteger.	"The first of two alternating numerators"
	denom1 := 1.		"The first of two alternating denominators"
	num2 := 1.		"The second numerator"
	denom2 := 0.		"The second denominator--will update"
	int := num1.		"The integer part of self"
	frac := self fractionPart.		"The fractional part of self"
	[frac = 0 or: [denom1 > maxDenominator] or: [denom2 > maxDenominator]]
		whileFalse: 
			["repeat while the fractional part is not zero and max order is not reached"
			newD := 1.0 / frac.			"Take reciprocal of the fractional part"
			int := newD asInteger.		"get the integer part of this"
			frac := newD fractionPart.	"and save the fractional part for next time"
			temp := num2.				"Get old numerator and save it"
			num2 := num1.				"Set second numerator to first"
			num1 := num1 * int + temp.	"Update first numerator"
			temp := denom2.				"Get old denominator and save it"
			denom2 := denom1.			"Set second denominator to first"
			denom1 := int * denom1 + temp.		"Update first denominator"].
	"If fractional part is zero, return the first ratio"
	denom1 = 1
		ifTrue: ["Am I really an Integer?"
				^ num1 "Yes, return Integer result"]
		ifFalse: ["Otherwise return Fraction result" 
				denom1 > maxDenominator 
					ifTrue: [^ Fraction numerator: num2 denominator: denom2].
				^ Fraction numerator: num1 denominator: denom1]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
asB64

	"'Hi there!!' asB64"

	| ss | 

	ss := ReadWriteStream on: (String new).
	ss nextPutAll: self.

	^ (Base64MimeConverter mimeEncode: ss) contents asOneLine.
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
asB64

	^ self asString asB64! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:44'!
asBoldText

	^ (Text fromString: self) 
		addAttribute: (TextEmphasis bold)! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 14:54'!
asBoldText

	^ self addAttribute: (TextEmphasis bold)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
asButton

	| label |

	label := (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
		whenEmpty: [^ self].

	(MenuMorph new add: label	target: self action: #openInHand)
		stayUp: true; openInHand! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asCodeText

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: self);
		addAttribute: (TextColor blue)! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:11'!
asCodeText

	^ self asEvalText: self! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:11'!
asColoredText: aColor

	^ (Text fromString: self) asColoredText: aColor! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:00'!
asColoredText: aColor

	^ self addAttribute: (TextColor color: aColor)! !

!Complex methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
asComplex

	^ self! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
asComplex

	^ Complex real: x imaginary: y! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asEvalText: someCode

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: someCode);
		addAttribute: (TextColor blue)! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:11'!
asEvalText: someCode

	^ self 
		addAttribute: (TextDoIt evalString: someCode);
		addAttribute: (TextColor blue)! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asExplicitEvalText: someCode

	^ (self asEvalText: someCode),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt  
							evalString: '''', someCode asB64, ''' openB64InWorkspace');
		addAttribute: (TextColor magenta))! !

!Fraction methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 12:04'!
asFastNumber

	^ self asFloat! !

!LargeNegativeInteger methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 12:06'!
asFastNumber

	^ self asFloat
! !

!LargePositiveInteger methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 12:07'!
asFastNumber

	^ self asFloat
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 12:03'!
asFastNumber

	^ self! !

!ScaledDecimal methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 12:04'!
asFastNumber

	^ self asFloat! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 13:22'!
asFastNumber

	^ self asNumber asFastNumber! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/19/2009 13:23'!
asFastNumber

	^ self asNumber asFastNumber! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 6/8/2012 23:25'!
asIntegerOrDigit

	self size = 1 ifFalse: [^ self asSignedInteger].
	
	^ self first asciiValue - 48! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 3/24/2013 17:28'!
asIntegerWhenClose

	| int |

	int := self rounded.
	(int veryCloseTo: self) ifTrue: [^ int].
	
	^ self! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asMGraphDocText

	| txt |

	txt := self asText.

	(MGraph classes collect: [:ea | ea asString])
		do: [:ea | | c |
				(c := txt findString: ea startingAt: 1)
					isZero ifFalse: 
					[txt addAttribute: (TextDoIt evalString: (ea, ' showDocumentation'))
						  from: c to: (c + ea size).
					 txt addAttribute: (TextColor magenta) from: c to: (c + ea size).]].

	^ txt! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
asNewMorphInHand

	^ self new asMorph openInHand! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
asOneLine

	^ self reject:[:each | each == Character cr]! !

!Complex methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
asPoint

	^ real @ imaginary! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asTextThatSend: aSelector toClass: aClass 

	| scl ssel |

	scl := aClass asString.
	ssel := aSelector asString.

	^ (self asEvalText: scl, ' perform:#', ssel),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt evalString: 'Browser fullOnClass: ', scl, ' class selector: #', ssel);
		addAttribute: (TextColor magenta))! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:05'!
asUnderlinedText

	^ (Text fromString: self) asUnderlinedText! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/15/2013 15:04'!
asUnderlinedText

	^ self addAttribute: (TextEmphasis underlined)! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/23/2010 09:56'!
askIfAddStyle: priorMethod req: requestor
	"Ask the user if we have a complex style (i.e. bold) for the first time"

	"spfa's fix: no, don't ask, and never style"		
	^ self asString! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 1/31/2012 17:07'!
associationsDetect: aBlock 

	self associationsDo: [ :each | (aBlock value: each) ifTrue: [^ each]].
	self errorNotFound: aBlock
! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 9/28/2011 23:22'!
atAbbrevedKey: aStringOrSymbol

	"All keys are supposed to be symbols"
	
	| k |
	
	(self includesKey: aStringOrSymbol) ifTrue: [^ self at: aStringOrSymbol].
	
	k := self keys detect: [:ky | ky orderlyIncludesAllOf: aStringOrSymbol].

	^ self at: aStringOrSymbol asSymbol put: (self at: k)! !

!FloatArray methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:09'!
atFloat: aNumber

	| n vn vnp |

	n := aNumber floor.
	vn := self at: n.
	vnp := (n = self size)
		ifTrue: [self at: 1]
	 	ifFalse: [self at: n + 1].
	^ vn + ((aNumber - n) * (vnp - vn))
	! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 9/30/2013 11:17'!
atOrigin

	^ 0.0@0.0! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 11/18/2009 18:13'!
balloonText

	^ balloonText! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
balloonText: aText

	balloonText := aText! !

!Array methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:04'!
bareLiteralPrintString

	"Mostly useful to pretty print in a readable format an Array of symbols"

	^ String streamContents: [:str | self printAsBareLiteralFormOn: str]
! !

!Fraction methodsFor: '*People-spfa-utils' stamp: 'spfa 9/23/2012 11:51'!
barePrintOn: aStream

	numerator printOn: aStream.
	aStream nextPut: $/. 
	denominator printOn: aStream! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:05'!
barePrintOn: aStream

	self printOn: aStream! !

!Symbol methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:00'!
barePrintOn: aStream 

	(Scanner isLiteralSymbol: self)
		ifTrue: [aStream nextPutAll: self]
		ifFalse: [super storeOn: aStream]! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 19:15'!
baseColor: aColor

	inactiveColor := aColor.
	self color: aColor! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 11/18/2009 18:13'!
bePermanent

	self getProperty: #permanent.
	self borderColor: Color green muchDarker
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 11/18/2009 18:13'!
beSmall

	self 
		 extent: 80@50;
		borderWidth: 1.
		
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 11/18/2009 18:13'!
beTemporary

	self getProperty: #temporary.
	
	! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 9/2/2012 22:56'!
beforeObject: target ifAbsent: exceptionBlock
	"Answer the receiver's element immediately before target. Answer
	the result of evaluating the exceptionBlock if target is not an element
	of the receiver, or if there are no elements before it."

	| index |
	index := self identityIndexOf: target.
	^ (index == 0 or: [index == 1])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index - 1]! !

!PluggableTextMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
benchIt
	| result |
	self handleEdit:
		[result := textMorph editor compileSelectionAsBlock.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [^self flash]].

	self inform: result bench! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
book

	BookMorph allSubInstances do: [:b |
		(b pages includes: self) ifTrue: [^ b]].

	^ nil! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
bottomCenter: aPoint

	self center: aPoint.
	self bottom: aPoint y! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
bringBackOutsideMorphs

	"moves all morphs which bounds are not contained within the receiver bounds"

	(self submorphs 
		select: [:m | ((bounds extendBy: 1) containsPoint: m bounds corner) not])
	do: [:m | m setConstrainedPosition: m position hangOut: false ]! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 23:51'!
browseDirectory

	(FileList2 morphicViewOnDirectory: directory) openInWorld! !

!Project methodsFor: '*People-spfa-utils' stamp: 'spfa 9/19/2012 10:15'!
buildJumpToMenu: menu
	"Make the supplied menu offer a list of potential projects, consisting of:
		*	The previous-project chain
		*	The next project, if any
		*	The parent project, if any
		*	All projects, alphabetically or hierarchically"

	| prev listed i next |
	listed := OrderedCollection with: self.
	i := 0.

	"The previous Project chain"
"	prev := self previousProject.
	[(prev ~~ nil and: [(listed includes: prev) not])] whileTrue:
	  [i := i + 1.
		listed add: prev.
		self 	addItem: prev name , ' (', ('back {1}' translated format:{i}  ), ')'
				toMenu: menu 
				selection: ('%back' , i printString) 
				project: prev.
		prev := prev previousProject].
	i > 0 ifTrue: [menu addLine]."


	"Then the next Project"
"	(((next := self nextProject) ~~ nil) and: [(listed includes: next) not]) ifTrue:
		[self	addItem: (next name, ' (', ('forward {1}' translated format:{1}), ')') 
				toMenu: menu 
				selection: next name 
				project: next]. 
	next ~~ nil ifTrue: [menu addLine]."

	"Then the parent"
	self isTopProject ifFalse: 
		[self	addItem: self parent name , ' (', 'parent' translated, ')' 
				toMenu: menu 
				selection: #parent 
				project: self parent.
		  menu addLine].

	"Finally all the projects, in hierarchical or alphabetical order:"
	(Preferences alphabeticalProjectMenu
			ifTrue:
				[Project allNamesAndProjects]
			ifFalse:
				[Project hierarchyOfNamesAndProjects]) do:

		[:aPair | | toAdd | 
			toAdd := aPair last isCurrentProject
				ifTrue:
				  [aPair first, ' (', 'current' translated, ')']
				ifFalse:
				  [aPair first].
			self	addItem: toAdd 
				toMenu: menu 
				selection: aPair first 
				project: aPair last].
	^ menu! !

!Project class methodsFor: '*People-spfa-utils' stamp: 'spfa 9/19/2012 10:10'!
buildJumpToMenu: menu
	"Make the supplied menu offer a list of potential projects, consisting of:
		*	The previous-project chain
		*	The next project, if any
		*	The parent project, if any
		*	All projects, alphabetically or hierarchically"

	| listed i  toAdd |
	listed := OrderedCollection with: CurrentProject.
	i := 0.

	"The previous Project chain"
"	prev := CurrentProject previousProject.
	[(prev ~~ nil and: [(listed includes: prev) not])] whileTrue:
	  [i := i + 1.
		listed add: prev.
		self 	addItem: prev name , ' (back ' , i printString , ')'
				toMenu: menu 
				selection: ('%back' , i printString) 
				project: prev.
		prev := prev previousProject].
	i > 0 ifTrue: [menu addLine]."


	"Then the next Project"
"	(((next := CurrentProject nextProject) ~~ nil) and: [(listed includes: next) not]) ifTrue:
		[self	addItem: (next name, ' (forward 1)') 
				toMenu: menu 
				selection: next name 
				project: next]. 
	next ~~ nil ifTrue: [menu addLine]."

	"Then the parent"
	CurrentProject isTopProject ifFalse: 
		[self	addItem: CurrentProject parent name , ' (parent)' 
				toMenu: menu 
				selection: #parent 
				project: CurrentProject parent.
		  menu addLine].

	"Finally all the projects, in hierarchical or alphabetical order:"
	(Preferences alphabeticalProjectMenu
			ifTrue:
				[Project allNamesAndProjects]
			ifFalse:
				[Project hierarchyOfNamesAndProjects]) do:

		[:aPair | 
			toAdd := aPair last isCurrentProject
				ifTrue:
				  [aPair first, ' (current)']
				ifFalse:
				  [aPair first].
			self	addItem: toAdd 
				toMenu: menu 
				selection: aPair first 
				project: aPair last].
	^ menu! !

!CollapsedMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/18/2009 18:08'!
buildWindowMenu
	"Answer the menu to be put up in response to the user's clicking on the window-menu control in the window title.  Specialized for CollapsedMorphs."

	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'change name...' translated action: #relabel.
	aMenu add: 'expand' translated action: #collapseOrExpand.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.	
	aMenu add: 'send to project...' translated action: #sendToAnotherProject.
	aMenu add: 'copy to project...' translated action: #copyToAnotherProject.
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	^aMenu! !

!SystemWindow methodsFor: '*People-spfa-utils-override' stamp: 'spfa 9/6/2010 16:54'!
buildWindowMenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'change title...' translated action: #relabel.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.	
	aMenu add: 'send to project...' translated action: #sendToAnotherProject.
	aMenu add: 'copy to project...' translated action: #copyToAnotherProject.
	aMenu addLine.
	aMenu add: self documentationReference notNil yesNoString, 
					'is muO documentation' action: #toggleDocumentationStatus.

	self documentationReference ifNotNil: [
		aMenu add: 'documentation settings' action: #beDocumentation;
				add: '(do not release)' toggleForProperty: #noRelease;
				add: 'save to file' action: #saveOnUsualFile;
				add: 'get load button' action: #getLoadButton].
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	aMenu addLine.
	aMenu add: 'full screen' translated action: #fullScreen.
	self isCollapsed ifFalse: [aMenu add: 'window color...' translated action: #setWindowColor].
	^aMenu! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 11/18/2009 18:09'!
buttonMaker

	^ (self sendMorphTo: nil via: #asButton) bePermanent label: '-> button'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
buttonName

	^ self knownName ifNil: [self name]! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 09:26'!
cache: aBlock

	^ self cache: aBlock under: thisContext sender selector
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 09:27'!
cache: aBlock at: anObject

	^ self cache: aBlock at: anObject under: thisContext sender selector
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 13:43'!
cache: aBlock at: aNumber under: aSelector

	| n |
	
	n := aNumber.
	n isFloat ifTrue: [n := (aNumber * 100000) truncated].

	^ (self at: aSelector ifAbsentPut: Dictionary new) at: n ifAbsentPut: aBlock
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 13:42'!
cache: aBlock under: aSelector

	^ self at: aSelector ifAbsentPut: aBlock.
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 13:43'!
cacheCopy: aBlock at: anObject

	^ self cacheCopy: aBlock at: anObject under: thisContext sender selector
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 13:42'!
cacheCopy: aBlock at: aNumber under: aSelector

	| n o |
	
	n := aNumber.
	n isFloat ifTrue: [n := (aNumber * 100000) truncated].

	o := (self at: aSelector ifAbsentPut: Dictionary new) at: n ifAbsentPut: aBlock.
	
	o isLiteral ifFalse: [^ o deepCopy].
	
	^ o
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/7/2013 13:41'!
cacheCopy: aBlock under: aSelector

	| o |

	o := self at: aSelector ifAbsentPut: aBlock.
	o isLiteral ifFalse: [^ o deepCopy].
	^ o
! !

!Dictionary methodsFor: '*People-spfa-utils-caching' stamp: 'spfa 3/21/2013 15:36'!
cachedAt: aNumber under: aSelector

	| n |
	
	n := aNumber.
	n isFloat ifTrue: [n := (aNumber * 100000) truncated].

	^ (self at: aSelector ifAbsentPut: Dictionary new) at: n ifAbsent: [^ nil]
! !

!SystemWindow methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
careAboutDamage: aRectangle 

	^ true! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/8/2010 13:37'!
categoriesAndMethodsOf: aClass build: aBlock

	^ self methodsOf: aClass inCategories: aClass organization categories build: aBlock
! !

!MPEGSubtitlesDisplayer methodsFor: 'menu' stamp: 'dgd 3/8/2004 20:42'!
changeFont
	"open a dialog to change the receiver's font"
	| newFont |
	newFont := StrikeFont fromUser: self font.
	""
	newFont isNil
		ifFalse: [self font: newFont]! !

!MPEGSubtitlesDisplayer methodsFor: 'menu' stamp: 'dgd 3/8/2004 20:10'!
changeSubtitlesColor
	"offer a ColorPicker to change the subtitles colors"

	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #textColor:;
		originalColor: self textColor;
		putUpFor: self currentHand near: self currentHand cursorBounds
! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 7/18/2013 13:01'!
checkRectangle: r color: c

	self checkRectangle: r width: 1 color: c! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 7/18/2013 13:00'!
checkRectangle: r width: w color: c

	self line: r topLeft to: r bottomRight width: w color: c.
	self line: r topRight to: r bottomLeft width: w color: c.! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
cleanUp

	self allInstances do: [:mm | mm removeProperty: #actualSubMenu]
! !

!VanishingMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/21/2010 13:50'!
cleanUp

	self allInstances do: [:m | m delete]! !

!SketchEditorMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
clearEnclosingPasteUpMorph
	enclosingPasteUpMorph := nil! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 2/26/2013 16:12'!
closeTo: anInterval

	^ (start closeTo: anInterval start) and: [stop closeTo: anInterval stop]! !

!Point methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 11/18/2009 18:15'!
closeTo: aPoint

	^ (x closeTo: aPoint x) and: [y closeTo: aPoint y]! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
closestMultipleOf: anInteger

	^ (self / anInteger) rounded * anInteger! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
compare: before to: after

	| diffSpace |

	before results size ~= after results size 
		ifTrue: [self error: 'different sets of classes are not supported yet'].

	diffSpace := 0.

	(StringHolder new contents: (String streamContents: 
			[:s | 
			before results with: after results do: [:bitem :aitem |
				bitem spaceForInstances = aitem spaceForInstances ifFalse:
				[
					bitem printOn: s.
					s cr.
					aitem printOn: s.
					s cr;cr.
					diffSpace := diffSpace + (aitem spaceForInstances - bitem spaceForInstances).

				]].
			s nextPutAll: ('Total difference: %s bytes' sformat: diffSpace)]))
		openLabel: 'Differential Space Analysis'.
		! !

!SpaceTally methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
computeSpaceUsageWithProgress: aString

	| n |

	n := 0.

	aString
	displayProgressAt: Sensor cursorPoint
	from: 0 to: results size
	during: [:bar |
		| entry c instanceCount |
		1 to: results size do: [:i |
			entry := results at: i.
			c := self class environment at: entry analyzedClassName.
			instanceCount := c instanceCount.
			entry codeSize: c spaceUsed.
			entry instanceCount: instanceCount.
			entry spaceForInstances: (self spaceForInstancesOf: c withInstanceCount: instanceCount).
			bar value: (n := n+1).
			Smalltalk garbageCollectMost]].
	
! !

!UserDialogBoxMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/17/2013 10:44'!
confirm: aString title: titleString trueChoice: trueChoice falseChoice: falseChoice nilChoice: nilChoice

	^self new
		title: titleString;
		label: aString;
		addSelectedButton: '   ', trueChoice translated, '   ' value: true;
		addCancelButton: '   ', falseChoice translated, '   '  value: false;
		addCancelButton: '   ', nilChoice translated, '   '  value: nil;
		runModalIn: ActiveWorld forHand: ActiveHand at: nil! !

!MPEGSubtitlesDisplayer methodsFor: 'target access' stamp: 'dgd 3/8/2004 20:36'!
contentsFromTarget
	"private - answer the contents from the receiver's target"
	| contentsAsText |
	contentsAsText := super contentsFromTarget asText.
	contentsAsText
		addAttribute: (TextFontReference toFont: self font).
	^ contentsAsText! !

!UpdatingTextMorph methodsFor: 'target access' stamp: 'nk 8/30/2004 16:18'!
contentsFromTarget
	"private - answer the contents from the receiver's target"
	(target isNil
			or: [getSelector isNil])
		ifTrue: [^ self contents].
	""
	^ (target perform: getSelector) asString! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 2/16/2012 18:34'!
copyIdentityWithout: oldElement 

	^ self reject: [:each | each == oldElement]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 8/16/2012 16:13'!
copyInsert: anObject at: index

	^ self copyReplaceFrom: index to: index-1 with: {anObject}
	
	! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 6/8/2010 10:17'!
copyInserting: anObject

	"the receiver is supposed to be sorted !!"
	
	| beg |
	
	beg := self select: [:ea | ea <= anObject].
	^ beg, (self species with: anObject), (self copyFrom: beg size + 1 to: self size)
	
	! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
copyToAnotherProject

	| target |
	
	target := Project queryProject ifNil: [^ self].
	target world addMorph: self veryDeepCopy! !

!Rectangle class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/10/2010 13:52'!
corners: twoPoints

	| p1 p2 |
	
	p1 := twoPoints first.
	p2 := twoPoints second.

	^ ((p1 x min: p2 x) @ (p1 y min: p2 y)) corner: ((p1 x max: p2 x) @ (p1 y max: p2 y))! !

!HaloMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 9/4/2014 16:33'!
createHandleAt: aPoint color: aColor iconName: iconName 
	| specialHandles bou handle color |
	bou := Rectangle center: aPoint extent: self handleSize asPoint.
	specialHandles := self handleSize > 20.
	color := specialHandles ifFalse: [aColor] ifTrue: [aColor alpha: 0.8].
	(Preferences alternateHandlesLook or: [specialHandles])
		ifTrue: [
			handle := RectangleMorph newBounds: bou color: aColor.
			handle borderWidth: 0.
			handle useRoundedCorners.
			self setColor: color toHandle: handle]
		ifFalse: [handle := EllipseMorph newBounds: bou color: aColor].
	""
	specialHandles ifTrue: [handle borderWidth: 1].
	handle borderColor: (aColor muchDarker alpha: 0.7).	.
	handle wantsYellowButtonMenu: false.
	""
	iconName isNil
		ifFalse: [| form | 
			form := ScriptingSystem formAtKey: iconName.
			form isNil
				ifFalse: [| image | 
					image := ImageMorph new.
					image image: form.
					image color: aColor makeForegroundColor.
					image lock.
					handle addMorphCentered: image]].
	""
	^ handle! !

!SequenceableCollection methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 2/17/2014 14:09'!
cyclicGenerator

	^ Generator on: [:g | | n | 
	n := -1.
	[g yield: (self at: ((n := n + 1) \\ self size) + 1) nextIfAny] repeat].! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2010 22:41'!
deepAt: anArray

	| vord |
	
	vord := self.
	anArray do: [:symb | vord := vord at: symb asSymbol].
	^ vord! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2010 22:42'!
deepAt: anArray put: anObject

	| d |
	
	d := self.
	anArray allButLast do: [:symb | d := d at: symb asSymbol ifAbsent: 
		[d at: symb asSymbol put: IdentityDictionary new]].
	^ d at: anArray last put: anObject.! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
defaultFileName

	(self documentationReference notNil and:
		[self documentationReference file notNil])
	ifTrue: [^ self documentationReference file].

	^ self possibleFileName! !

!UndefinedObject methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
deleteAll
	AllBlobs := nil! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/12/2010 22:03'!
deleteSubMenu

	self actualSubMenu ifNotNil: [self actualSubMenu delete].
	self actualSubMenu: nil.
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda morphDependents: anArray thenDo: lastLambda

	| o |

	o := GenericInputMorph request: aString 
			initialAnswer: iLambda lambdaValue asString
			initialMorphicLambda: Lambda morph deliver etaAbstracted
			morphDependents: anArray
			test: (Lambda morph transportsA: LambdaMessageSend).

	o isString ifTrue:
	[ 
		o ifEmpty: [^ self].
		o := Compiler evaluate: o
	].

	aLambdaExpression withUnlimitedEvaluation valueWithArguments: {o value}.
	lastLambda value

! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda thenDo: lastLambda

	self deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda morphDependents: #() thenDo: lastLambda


! !

!DockingBarItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/9/2010 22:52'!
deselect
	self isSelected: false.
	lastMousePosition := nil.
	subMenu ifNotNil: [
		owner ifNotNil:[owner activeSubmenu: nil. self deleteSubMenu].
		self removeAlarm: #deselectTimeOut].! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/14/2010 15:44'!
deselect
	self isSelected: false.
	lastMousePosition := nil.
	self subMenu ifNotNil: [
		owner ifNotNil:[owner activeSubmenu: nil. self deleteSubMenu].
		self removeAlarm: #deselectTimeOut].! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/12/2010 22:05'!
deselectItem
	| item |
	self isSelected: false.
	self actualSubMenu ifNotNil: [self actualSubMenu deleteIfPopUp].
	(owner isKindOf: MenuMorph) ifTrue:
		[item := owner popUpOwner.
		(item isKindOf: MenuItemMorph) ifTrue: [item deselectItem]].
! !

!DockingBarItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/10/2010 09:45'!
deselectTimeOut
	"Deselect timout. Now really deselect"

	| outInBar |
	
	owner ifNil: [^ self].
	owner selectedItem == self ifFalse: [^ self].

	outInBar := (ActiveHand position y < owner height)
		and: [ActiveHand position x <= 1 
			or: [ActiveHand position x > (owner findA: AlignmentMorph) left]].
	
	(outInBar not
		and: [(subMenu notNil and: [subMenu owner notNil]) or: [owner isUnderHand]]) 
	ifTrue:
		[^ self addAlarm: #deselectTimeOut at: Time primMillisecondClock + 100].			
	self activeHand newMouseFocus: nil.
	
	self deselect! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 9/19/2012 10:02'!
deselectTimeOut
	"Deselect timout. Now really deselect"

	| sm |
	
	owner selectedItem == self ifFalse: [^ self].

	(((sm := self actualSubMenu) notNil 
			and: [sm owner notNil]
			and: [owner popUpOwner notNil])
		or: [owner isUnderHand])
	ifTrue:
		[self removeAlarm: #deselectTimeOut.
		^ self addAlarm: #deselectTimeOut at: Time primMillisecondClock + 300].	
			
"	self activeHand newMouseFocus: nil.		"
	self deselect.
	"self activeHand newMouseFocus: self topOwnerMenu."

! !

!Character methodsFor: '*People-spfa-utils' stamp: 'spfa 11/30/2009 14:13'!
deshex

	^ ('0123456789ABCDEF' indexOf: self asUppercase) -1! !

!Preference methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 4/16/2010 19:21'!
dictionarySymbol

	^ name! !

!Integer methodsFor: '*People-spfa-utils' stamp: 'spfa 3/4/2014 11:36'!
digits

	| integer next result n |
	
	self < 0 ifTrue: [^ self negated digits].
	
	result := Array new: (n := self numberOfDigitsInBase: 10).
	integer := self.
	n to: 1 by: -1 do: [:i |
		next := integer // 10.
		result at: i put: (integer - (next * 10)).
		integer := next].
	^result! !

!BorderedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/4/2010 15:32'!
dim

	"no-op; for compatibility only"! !

!IconicButton methodsFor: '*People-spfa-utils' stamp: 'spfa 5/4/2010 15:18'!
dim

	"no-op; for compatibility only"! !

!CollapsedMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 5/5/2010 16:16'!
dimWindowButtons

	uncollapsedMorph isSystemWindow ifFalse: [^ self].
	super dimWindowButtons! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/28/2010 15:57'!
directory: aFileDirectory

	directory := aFileDirectory.
	lastFile := nil.
	self smallLabel: aFileDirectory pathParts last! !

!ClassDescription methodsFor: '*people-spfa-utils' stamp: 'spfa 4/8/2010 21:08'!
displayComment

	self organization classComment openInWorkspaceWithTitle: self name, ' class comments'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2011 12:23'!
displayToUser

	^ self openInHalo! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
displayWithLabel: aString 

	self asText displayWithLabel: aString ! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
displayWithLabel: aString 

	self displayWithLabel: aString onColor: Color tan darker.
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
displayWithLabel: aString onColor: aColor
	"Open up a system window with the receiver as its contents, with the given title"

	| w |

	w := SystemWindow labelled: aString.
	w paneColor: aColor.
	w addMorph: (PluggableTextMorph on: self text: #asText accept: nil) frame: (0@0 corner: 1@1).

	w openInWorld
! !

!PositionableStream methodsFor: '*People-spfa-utils' stamp: 'spfa 5/26/2011 21:48'!
do: aBlock whilePeekingAt: aCharacterSet

	[self atEnd not
		and: [aCharacterSet includes: self peek]] 
	whileTrue: aBlock! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:17'!
doButtonAction
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	| t |

	t := target lambdaValue.

	(t notNil and: [actionSelector notNil]) 
		ifTrue: 
			[Cursor normal 
				showWhile: [t perform: actionSelector withArguments: arguments].
			t isMorph ifTrue: [t changed]]! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:17'!
doButtonAction: evt
	| moreArgs |
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	target ifNil: [^self].
	actionSelector ifNil: [^self].
	Cursor normal showWhile: [
		moreArgs := actionSelector numArgs > arguments size ifTrue: [
			arguments copyWith: evt
		] ifFalse: [
			arguments
		].
		target lambdaValue perform: actionSelector withArguments: moreArgs
	]! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 2/11/2013 10:30'!
doNothingWith: anObject

	^ anObject! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
doThen

	| then |

	then := (self valueOfProperty: #then) ifNil: [^ self].

	then isSymbol 
		ifTrue: [defaultTarget perform: then]
		ifFalse: [then value]
	! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:35'!
doWhileWaitingFor: aNumber

	"wait for aNumber milliseconds and evaluate the receiver in the meantime if possible, else evaluate it anyway (in wich case more time than aNumber milliseconds will have elapsed by the end of the method)"

	| dt |

	dt := (aNumber - [self value] timeToRun).
	dt negative ifFalse: [(Delay forMilliseconds: dt) wait].

	^ dt negated
! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:35'!
doWhileWaitingFor: aNumber

	"wait for aNumber milliseconds and evaluate the receiver in the meantime if possible, else evaluate it anyway (in wich case more time than aNumber milliseconds will have elapsed by the end of the method)"

	| dt |

	dt := (aNumber - [self value] timeToRun).
	dt negative ifFalse: [(Delay forMilliseconds: dt) wait].

	^ dt negated
! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:36'!
doWhileWaitingFor: aNumber onFailure: bBlock

	^ self doWhileWaitingFor: aNumber onSuccess: [:dt | dt] onFailure: bBlock

! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:36'!
doWhileWaitingFor: aNumber onFailure: bBlock

	^ self doWhileWaitingFor: aNumber onSuccess: [:dt | dt] onFailure: bBlock

! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:36'!
doWhileWaitingFor: aNumber onSuccess: aBlock onFailure: bBlock

	| dt |

	^ (dt := self doWhileWaitingFor: aNumber) negative 
		ifTrue: [aBlock value: dt] 
		ifFalse: [bBlock value: dt]
! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2010 21:36'!
doWhileWaitingFor: aNumber onSuccess: aBlock onFailure: bBlock

	| dt |

	^ (dt := self doWhileWaitingFor: aNumber) negative 
		ifTrue: [aBlock value: dt] 
		ifFalse: [bBlock value: dt]
! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:09'!
doubleClick: evt

	self bePermanent.
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/2/2010 10:18'!
doubleHeight

	self height: 2 * self height! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2010 13:39'!
down

	^ self top min: self bottom! !

!DropReporter methodsFor: 'drawing' stamp: 'spfa 11/18/2009 18:09'!
drawOn: aCanvas

	| innerRectangle |

	innerRectangle := self bounds expandBy: 
							((self height min: self width) /// 3) asInteger negated.

	super drawOn: aCanvas.
	aCanvas line: self topLeft to: innerRectangle topLeft color: Color grey.
	aCanvas line: self bottomLeft to: innerRectangle bottomLeft color: Color grey.
	aCanvas line: self topRight to: innerRectangle topRight color: Color grey.
	aCanvas line: self bottomRight to: innerRectangle bottomRight color: Color grey! !

!MenuLineMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 4/26/2013 18:12'!
drawOn: aCanvas 
	| baseColor |
	baseColor := Preferences menuColorFromWorld
				ifTrue: [owner color twiceDarker]
				ifFalse: [Preferences menuAppearance3d
						ifTrue: [owner color]
						ifFalse: [Preferences menuLineColor]].
	
	baseColor isTransparent ifTrue: [baseColor := (Color r: 0.95 g: 0.95 b: 0.95)].				
					
	Preferences menuAppearance3d
		ifTrue: [
			aCanvas
				fillRectangle: (bounds topLeft corner: bounds rightCenter)
				color: baseColor twiceDarker.
			
			aCanvas
				fillRectangle: (bounds leftCenter corner: bounds bottomRight)
				color: baseColor twiceLighter]
		ifFalse: [
			aCanvas
				fillRectangle: (bounds topLeft corner: bounds bottomRight)
				color: baseColor]! !

!MenuSliderItemMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2013 14:26'!
drawOn: aCanvas 
	| stringColor stringBounds |
	
	stringColor := color.
	stringBounds := bounds.

	stringBounds := stringBounds top: stringBounds top + stringBounds bottom - self fontToUse height // 2.
	aCanvas
		drawString: contents
		in: stringBounds
		font: self fontToUse
		color: stringColor.
! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 12/13/2013 09:52'!
drawOpaqueString: s at: pt color: aColor

	^ self drawString: s from: 1 to: s size at: pt font: nil color: aColor backgroundColor: Color white! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 12/13/2013 09:53'!
drawOpaqueStrings: aCollection at: pt color: aColor

	| th |

	th := TextStyle defaultFont height ceiling + 2.

	aCollection doWithIndex: [:s : i |
		self drawOpaqueString: s at: pt + (0@((i-2) * th)) color: aColor]! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 5/20/2010 22:00'!
drawString: s endingAt: pt font: aFont color: aColor

	^ self drawString: s 
		at: (pt - (((aFont ifNil: [TextStyle defaultFont ])widthOfString: s) @0))
		font: aFont color: aColor! !

!FormCanvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
drawString: aString from: firstIndex to: lastIndex at: aPoint font: fontOrNil color: c backgroundColor: d
	| font |
	port colorMap: nil.
	font := fontOrNil ifNil: [TextStyle defaultFont].
	port combinationRule: Form paint.
	font installOn: port
		foregroundColor: (self shadowColor ifNil:[c]) 
		backgroundColor: d.
	font displayString: aString on: port 
		from: firstIndex to: lastIndex at: (origin + aPoint) kern: 0.! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2012 10:04'!
drawStrings: aCollection at: pt

	^ self drawStrings: aCollection at: pt font: nil color: Color black! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2012 10:05'!
drawStrings: aCollection at: pt color: aColor

	^ self drawStrings: aCollection at: pt font: nil color: aColor! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2012 10:07'!
drawStrings: aCollection at: pt font: aFont color: aColor

	| th |

	th := (aFont ifNil: [TextStyle defaultFont]) height ceiling + 2.

	aCollection doWithIndex: [:s : i |
		self drawString: s from: 1 to: s size 
			at: pt + (0@((i-2) * th))
			font: aFont color: aColor]! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
drawText: aText at: aPosition

	| form |

	self paintImage: (form := (TextMorph new contents: aText asText) imageForm) 
		at: aPosition - form boundingBox bottomCenter
! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
drawVerticalText: aText at: aPosition

	| form |

	self paintImage: (form := (TextMorph new contents: aText asText) imageForm rotateBy: 270) 
		at: aPosition - form boundingBox bottomCenter
! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
drawVerticalText: aText color: aColor at: aPosition

	| form txt |

	txt := aText asText addAttribute: (TextColor color: aColor).

	self paintImage: (form := (TextMorph new contents: txt) imageForm rotateBy: 270) 
		at: aPosition - form boundingBox bottomCenter
! !

!WorldState methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
drawWorld: aWorld submorphs: submorphs invalidAreasOn: aCanvas 
	"Redraw the damaged areas of the given canvas and clear the damage list. Return a collection of the areas that
were redrawn."

	| rectList c i n mm morphs rects rectToFill remnants rect validList |
	rectList := damageRecorder invalidRectsFullBounds: aWorld viewBox.
	"sort by areas to draw largest portions first"
	rectList := rectList asArray sort: [:r1 :r2 | r1 area > r2 area].
	damageRecorder reset.
	n := submorphs size.
	morphs := OrderedCollection new: n * 2.
	rects := OrderedCollection new: n * 2.
	validList := OrderedCollection new: n * 2.
	rectList do: 
			[:dirtyRect | 
			dirtyRect allAreasOutsideList: validList
				do: 
					[:r | 
					"Experimental top-down drawing --
			Traverses top to bottom, stopping if the entire area is filled.
			If only a single rectangle remains, then continue with the reduced rectangle."

					rectToFill := r.
					i := 1.
					[rectToFill isNil or: [i > n]] whileFalse: 
							[mm := submorphs at: i.
							((mm fullBounds intersects: r) and: [mm visible]
								and: [mm careAboutDamage: r]) 
								ifTrue: 
									[morphs addLast: mm.
									rects addLast: rectToFill.
									remnants := mm areasRemainingToFill: rectToFill.
									remnants size = 1 ifTrue: [rectToFill := remnants first].
									remnants isEmpty ifTrue: [rectToFill := nil]].
							i := i + 1].

					"Now paint from bottom to top, but using the reduced rectangles."
					rectToFill 
						ifNotNil: [aWorld drawOn: (c := aCanvas copyClipRect: rectToFill)].
					[morphs isEmpty] whileFalse: 
							[(rect := rects removeLast) == rectToFill 
								ifFalse: [c := aCanvas copyClipRect: (rectToFill := rect)].
							c fullDrawMorph: morphs removeLast].
					morphs reset.
					rects reset.
					validList add: r]].
	^validList! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
editAmongChoices: choices label: aString

	| w h |

	w := 500.
	h := (choices lineCount * TextStyle defaultFont height) min: 300.

	^ Compiler evaluate: 
		(((FillInTheBlankMorph
		 	request: aString
 			initialAnswer: choices
			centerAt: World center 
			inWorld: World 
			onCancelReturn: (choices lineNumber: 1) 
			acceptOnCR: false 
			answerExtent: w @ h) whenEmpty: [^ nil]) lineNumber: 1)! !

!PBBooleanPreferenceView methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 4/16/2010 19:22'!
enabledButton
	| aButton aLabel psel |

	psel := self preference dictionarySymbol.

	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: (Preferences lambda preferenceAt: psel);
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue;
		yourself.
	aLabel := (StringMorph contents: 'enabled' translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).
	^self horizontalPanel
		addMorphBack: aButton;
		addMorphBack: aLabel;
		yourself.! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
end

	^ stop! !

!HaloMorph methodsFor: '*People-spfa-utils-override' stamp: 'ul 12/12/2009 14:10'!
endInteraction
	"Clean up after a user interaction with the a halo control"

	| m |
	self isMagicHalo: false.	"no longer"
	self magicAlpha: 1.0.
	(target isInWorld not or: [owner isNil]) ifTrue: [^self].
	[target isFlexMorph and: [target hasNoScaleOrRotation]] whileTrue: 
			[m := target firstSubmorph.
			target removeFlexShell.
			target := m].
	self isInWorld 
		ifTrue: 
			["make sure handles show in front, even if flex shell added"

			self comeToFront.
			self addHandles].
	(self valueOfProperty: #commandInProgress) ifNotNil: 
			[:cmd | 
			self rememberCommand: cmd.
			self removeProperty: #commandInProgress]! !

!String methodsFor: '*People-spfa-utils-for-menu' stamp: 'yo 11/2/2004 20:45'!
evaluate

	^ Compiler evaluate: self! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/1/2013 11:02'!
expandVerticallyToMargin: anInteger

	self bounds: ((self bounds top: anInteger) bottom: World bottom - anInteger)! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
explorePointers
	PointerExplorer new openExplorerFor: self! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/11/2012 14:00'!
exportFormFromUserAsJPEG

	| form fName |
	
	form := Form fromUser.
	fName := UIManager default request: 'Export to file named' translated initialAnswer: 'Exported ', Date today asString, ' ', Time now hhmmss24 ,'.jpeg'.
	fName isEmpty ifTrue: [^ self].
	form writeJPEGfileNamed: fName
! !

!FloatArray methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:09'!
extrema

	| tmax tmin xts |

	xts := Set new.
	tmax := tmin := self at: 1.
	xts add: self size@self last.

	(1 to: self size) do: [:i |
		tmax ifNotNil:	[
			(self at: i) >= tmax 
				ifTrue: [tmax := self at: i	]
				ifFalse: [
					xts add: (i-1)@tmax.
					tmin := tmax.
					tmax := nil
				]].
		tmin ifNotNil: [
			(self at: i) <= tmin 
				ifTrue: [tmin := self at: i]
				ifFalse: [
					xts add: (i-1)@tmin.
					tmax := tmin.
					tmin := nil
				]]].

	^ xts asArray sortBy: [:p1 :p2 | p1 x < p2 x]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
findAll: aClass
	"Return an Array of all submorphs of the receiver that are descended from the given class"

	^self submorphs select: [:p | p isKindOf: aClass]
	! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
findBetween: aCharacter
	"Answer the collection of String tokens that result from parsing self.  Tokens are separated by aCharacter"

	| tokens keyStart keyStop |
	tokens := OrderedCollection new.
	keyStop := 1.
	[keyStop <= self size] whileTrue:
		[keyStart := self skip: aCharacter from: keyStop.
		keyStop := self indexOf: aCharacter startingAt: keyStart ifAbsent: [self size+1].
		keyStart < keyStop
			ifTrue: [tokens add: (self copyFrom: keyStart to: (keyStop - 1))]].
	^tokens! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
findEndOfString: aString  
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	| i |

	i := self findString: aString asString startingAt: 0 caseSensitive: false.
	i isZero ifTrue: [self error: 'no match'].
	^ i + aString size
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
findEndOfString: aString  
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	^ string findEndOfString: aString  
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
findEndOfString: aString  startingAt: index
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	| i |

	i := self findString: aString asString startingAt: index caseSensitive: false.
	i isZero ifTrue: [self error: 'no match'].
	^ i + aString size
! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
findString: subString
	"Answer the index of subString within the receiver, starting at start. If 
	the receiver does not contain subString, answer 0."
	^self findString: subString startingAt: 1.! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
findString: aString 
	"Answer the index of subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	^ string findString: aString  
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/29/2012 21:36'!
firstLine

	^ self lineCorrespondingToIndex: 1! !

!Bag class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
flatten: aCollection

	| fc | 

	fc := self new.

	aCollection do: [:el |
		el isCollection 
			ifTrue: [fc addAll: el]
			ifFalse: [fc add: el]].

	^ fc! !

!Bag class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
flattenDeeply: aCollection

	| fc | 

	fc := self new.

	aCollection do: [:el |
		el isCollection 
			ifTrue: [fc addAll: (self flattenDeeply: el)]
			ifFalse: [fc add: el]].

	^ fc! !

!MPEGSubtitlesDisplayer methodsFor: 'accessing' stamp: 'dgd 3/7/2004 21:18'!
font
	"answer the receiver's font"
	^ font
		ifNil: [TextStyle defaultFont] ! !

!MPEGSubtitlesDisplayer methodsFor: 'accessing' stamp: 'dgd 3/8/2004 20:33'!
font: aFont 
	"change the receiver's font"
	font := aFont.
	""
	self contents: ''.
	self contents: self contentsFromTarget! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
forceIn: anInterval

	^ (self max: anInterval start) min: anInterval end! !

!MessageSend methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
fork

	[self value] fork! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
fromB64

	"'SGkgVGhlcmUh' fromB64"

	| ss |

	ss := ReadWriteStream on: (String new).
	ss nextPutAll: self.

 	^ (Base64MimeConverter mimeDecodeToChars: ss) contents ! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 4/16/2010 20:52'!
fromLocalFileName: aString

 	^ (self readFromLocalFile: aString) openInWorld.
! !

!SequenceableCollection methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 2/17/2014 14:09'!
generator

	^ Generator on: [:g | self do: [ :value | g yield: value nextIfAny]]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
getCopyButton

	| label |

	label := (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
				whenEmpty: [^ self].

	(MenuMorph new add: ('+ ', label) target: self action: #openCopyInHand)
		stayUp: true; openInHand! !

!Morph methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 11/18/2009 18:13'!
getProperty: aSymbol

	self setProperty: aSymbol
		  toValue: true
					! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/17/2011 15:26'!
getReference

	"create a ghost-like TransferMorph with self as passenger and give it to the Hand"

	| form |
	
	form := self imageForm.
	form fill: form boundingBox rule: Form blend fillColor: (Color orange alpha: 0.4).

	^ (TransferMorph withPassenger: self) 
		color: Color transparent;
		extent: self extent;
		addMorph: form asMorph;
		source: self;
		openInHand! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:16'!
getSelector
	"answer the receiver's getSelector"
	^ getSelector! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:16'!
getSelector: aSymbol 
	"change the receiver's getSelector"
	getSelector := aSymbol! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 3/4/2012 17:27'!
groupsOf: n do: aBlock 
	"Evaluate aBlock with my elements taken n at a time.
	aBlock must have a single argument: it will be passed an array of maximum n items (possibly less for the last group)"
	| lastIndex |

	n >= self size ifTrue: [^ aBlock value: self].

	lastIndex := 0.

	(n <= self size) ifTrue: [
		n to: self size by: n
			do: [:index | 
					aBlock value: (self copyFrom: index - n + 1 to: index) asArray.
					lastIndex := index]].

	(lastIndex < self size) ifTrue: [
			aBlock value: (self copyFrom: lastIndex + 1 to: self size) asArray]
		! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 6/8/2012 10:05'!
halfOpenRangeIncludes: aNumber
	
	step >= 0
		ifTrue: [^ (aNumber greaterOrCloseTo: start) and: [aNumber strictlyLessThan: stop]]
		ifFalse: [^ (aNumber greaterOrCloseTo: stop) and: [aNumber strictlyLessThan: start]]
! !

!Float class methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/13/2010 13:29'!
halfTurn

	"http://tauday.com
	http://en.wikipedia.org/wiki/Turn:=%28geometry%29"

	^ Pi! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/12/2012 16:18'!
haloEndInteraction! !

!HaloMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 12/2/2011 11:42'!
handleSize

	^ (self valueOfProperty: #handleSize) ifNil: [
		Preferences biggerHandles
			ifTrue: [20]
			ifFalse: [16]]! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:09'!
handlesMouseDown: evt
	^ true! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:16'!
handlesMouseOver: evt

	^ true! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 14:53'!
handlesMouseOver: evt

	^ true! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
hasSubMenu
	"Return true if the receiver has a submenu"
	^ subMenu notNil! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/13/2010 11:50'!
hasTitle

	submorphs isEmpty ifTrue: [^false].
	^ submorphs first isAlignmentMorph! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
hasUsualFile

	^ self usualFile notNil! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
height: aNumber

	^ self origin corner: self corner x @ (self corner y + aNumber)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/22/2010 22:14'!
horizontalAxis

	^ self center y! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
idString
	"return a string used to identify this morph in a part bin menu, or nil if this morph is not supposed to be available from there"

	^ nil! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 1/26/2013 15:02'!
identityAfter: target

	^ self identityAfter: target ifAbsent: [self errorNotFound: target]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2010 21:32'!
identityAfter: target ifAbsent: exceptionBlock
	"Answer the element after target.  Answer the result of evaluation
	the exceptionBlock if target is not in the receiver, or if there are 
	no elements after it."

	| index |
	index := self identityIndexOf: target.
	^ (index == 0 or: [index = self size])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index + 1]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 1/26/2013 15:02'!
identityBefore: target

	^ self identityBefore: target ifAbsent: [self errorNotFound: target]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2010 21:34'!
identityBefore: target ifAbsent: exceptionBlock
	"Answer the receiver's element immediately before target. Answer
	the result of evaluating the exceptionBlock if target is not an element
	of the receiver, or if there are no elements before it."

	| index |
	index := self identityIndexOf: target.
	^ (index == 0 or: [index == 1])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index - 1]! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
ifNotNilOr: anObject ifBothNotNil: aBlock

	anObject ifNil: [^ self].
	^ aBlock value! !

!UndefinedObject methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
ifNotNilOr: anObject ifBothNotNil: aBlock

	^ anObject! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 3/24/2013 17:28'!
ifNotNilOr: anObject ifBothNotNilAndDifferent: aBlock

	anObject ifNil: [^ self].
	(anObject veryCloseTo: self) ifTrue: [^ self].
	^ aBlock value! !

!UndefinedObject methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
ifNotNilOr: anObject ifBothNotNilAndDifferent: aBlock

	^ anObject ! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 1/28/2013 10:47'!
ignore: anObject

	^ self! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 18:59'!
inactiveColor

	^ inactiveColor ifNil: [inactiveColor := self color]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 3/1/2010 18:49'!
includesSubCollection: aSubCollection

	^ (self indexOfSubCollection: aSubCollection startingAt: 1) isZero not! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 2/8/2013 10:52'!
indexOfElementVerifying: aBlock

	self doWithIndex: [:ea :i |(aBlock value: ea) ifTrue: [^ i]].
	^ nil
! !

!InteractiveMorphOperator methodsFor: 'as yet unclassified' stamp: 'spfa 3/9/2010 14:13'!
initialize

	super initialize.
	self 
		borderWidth: 1;
		extent: 200@180; 
		useRoundedCorners;
		bePermanent.
! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/28/2010 15:59'!
initialize

	super initialize.
	self 
		borderWidth: 1;
		extent: 200@180; 
		useRoundedCorners;
		bePermanent.
	self directory: FileDirectory default.
	balloonText := 'Drop a MusicalPhrase to be written as a MIDI file'.
	self receiver: self selector: #save:.

	self addMenu! !

!MPEGSubtitlesDisplayer methodsFor: 'initialization' stamp: 'dgd 3/7/2004 21:16'!
initialize
	"initialiaze the receiver"
	super initialize.
	""
font := TextStyle defaultFont.""
	self
		backgroundColor: (Color black alpha: 0.4).
	""
	self margins: 4 @ 2.
	self textColor: Color white.
	self textStyle centered! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 11/18/2009 18:13'!
initialize

	super initialize.
	self color: (Color white alpha: 0.7);
		 extent: 100@100;
		borderColor: Color red;
		borderWidth: 3.
		
	self setProperty: #creationTime toValue: Time now
	! !

!UpdatingTextMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2004 20:17'!
initialize
	"Initialie the receiver to have default values in its instance  
	variables"
	super initialize.""
	stepTime := 50! !

!VanishingMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/21/2010 13:49'!
initialize

	super initialize.
	self color: Color transparent.
	self position: -100@ -100.
	[1 second asDelay wait. self delete] fork! !

!PBPreferenceButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 4/16/2010 19:22'!
initializeWithPreference: aPreference model: aModel
	
	| psel |

	psel := aPreference dictionarySymbol.

	preference := Preferences lambda preferenceAt: psel.
	model := aModel.
	self initializeLayout.
	self addMorphBack: self preferenceMorphicView.
	self highlightOff.! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
instanceInfoLine

	"displayed by the instances browser"

	^ self printString! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
instanceInfoText

	"displayed by the instances browser"

	| txt |

	txt := ''.

	self isMorph ifTrue:
		[txt := txt,  'in project: ', (self world ifNil: ['<NONE>']
												ifNotNil: [self world project name]), 
									String cr,
					  'owner: ', self owner asString, String cr].

	^ txt, 'known name: ', self knownName asString! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
instanceTypes
	"return nil or a dictionary providing different instance creation methods (values) associated to their names (keys), so that we can register different types of the morph in a part bin or a menu"

	^ nil! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
instanceTypesMenu

	| m |

	m := MenuMorph new.

	self instanceTypes keysAndValuesDo: [:k : val |
		m add: k lambda: (self lambda: val) openInHand].			

	^ m

! !

!FloatArray methodsFor: '*People-spfa-utils' stamp: 'spfa 4/8/2011 13:58'!
interpolateAt: aNumber

	| f dy x n vn vnp |

	aNumber < 0 ifTrue: [^ self first].
	aNumber >= 1 ifTrue: [^ self last].
	
	dy := self last - (f := self first).
	dy isZero ifTrue: [^ 0].

	x := aNumber * (self size -1).
	n := x truncated.
		
	vn := self at: n + 1.
	n + 1 = self size ifTrue: [^ vn].
	vnp := self at: n + 2.
	^ (vn + ((x - n) * (vnp - vn)) - f) / dy
	! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2010 09:40'!
interpolationAt: aNumber

	^ (self start min: self end) + (self width * aNumber)! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 2/26/2010 11:44'!
inverted

	| d |

	d := self species new.
	self keysAndValuesDo: [:k :v |
		d at: v put: k].
	^ d! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
invokeWithEvent: evt
	"Perform the action associated with the given menu item."

	| selArgCount w |
	self isEnabled ifFalse: [^ self].
	target class == HandMorph ifTrue: [(self notObsolete) ifFalse: [^ self]].
	owner ifNotNil:[self isStayUpItem ifFalse:[
		self flag: #workAround. "The tile system invokes menus straightforwardly so the menu might not be in the world."
		(w := self world) ifNotNil:[
			owner deleteIfPopUp: evt.
			"Repair damage before invoking the action for better feedback"
			w displayWorldSafely]]].
	selector ifNil:[^self].
	Cursor normal showWhile: [  "show cursor in case item opens a new MVC window"
		(selArgCount := selector numArgs) = 0
			ifTrue:
				[target perform: selector]
			ifFalse:
				[selArgCount = arguments size
					ifTrue: [target perform: selector withArguments: arguments]
					ifFalse: [target perform: selector withArguments: (arguments copyWith: evt)]]].

	owner notNil 
		ifTrue: [owner doThen]
	! !

!Array methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 11/18/2009 18:07'!
isArray

	^ true! !

!Object methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 11/18/2009 18:15'!
isArray

	^ false! !

!Association methodsFor: '*People-spfa-utils' stamp: 'spfa 9/23/2014 20:09'!
isAssociation

	^ true! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 9/23/2014 20:09'!
isAssociation

	^ false! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
isBetaDocumentation

	^ self hasProperty: #noRelease! !

!Character methodsFor: '*People-spfa-utils' stamp: 'spfa 7/21/2014 22:31'!
isBlank

	self asInteger = 32 ifTrue: [^true].	"space"
	self asInteger = 9 ifTrue: [^true].	"tab"
	^false! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 9/5/2013 20:32'!
isCloseToAnInteger

	^ self rounded closeTo: self! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
isFormCanvas

	^ false! !

!FormCanvas methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
isFormCanvas

	^ true! !

!Character methodsFor: '*People-spfa-utils' stamp: 'spfa 11/30/2009 13:51'!
isHexDigit

	^ self isDigit or: ['abcdefABCDEF' identityIncludes: self]
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2010 21:39'!
isInUnitInterval

	^ self >=0 and: [self <=1]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
isMenu

	^ true! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
isMenu

	^ false! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 11/18/2009 18:10'!
isPrime
	"See isProbablyPrimeWithK:andQ: for the algoritm description."
	| k q |
	self <= 1 ifTrue: [^self error: 'operation undefined'].
	self even ifTrue: [^self = 2].
	k := 1.

	q := self - 1 bitShift: -1.
	[q odd] whileFalse: 
			[q := q bitShift: -1.
			k := k + 1].
	
	25 timesRepeat: [(self isProbablyPrimeWithK: k andQ: q) ifFalse: [^false]].
	^true! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 11/18/2009 18:10'!
isProbablyPrimeWithK: k andQ: q 
	"Algorithm P, probabilistic primality test, from
	Knuth, Donald E. 'The Art of Computer Programming', Vol 2,
	Third Edition, section 4.5.4, page 395, P1-P5 refer to Knuth description."

	"P1"

	| x j y |
	x := (self - 2) atRandom + 1.
	"P2"
	j := 0.
	y := x raisedToInteger: q modulo: self.
	"P3"
	
	[(((j = 0) & (y = 1)) | (y = (self - 1))) ifTrue: [^true].
	((j > 0) & (y = 1)) ifTrue: [^false].	"P5"
	true]  
			whileTrue: 
				[j := j + 1.
				(j < k) ifTrue: [y := y squared \\ self]
				ifFalse:[^ false]]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
isTransferMorph

	^ false! !

!TransferMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
isTransferMorph

	^ true! !

!DockingBarMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/23/2013 19:18'!
isUnderHand

	^ (self boundsInWorld containsPoint: self activeHand position)
		or: [selectedItem notNil and: [| sm |
				(sm := selectedItem actualSubMenu) notNil
					and: [sm isUnderHand]]]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/23/2013 19:18'!
isUnderHand

	^ (self boundsInWorld containsPoint: self activeHand position)
		or: [selectedItem notNil and: [| sm |
				(sm := selectedItem actualSubMenu) notNil
					and: [sm isUnderHand]]]! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
itemWithWording: wording
	"If any of the receiver's items or submenu items have the given wording (case-blind comparison done), then return it, else return nil."
	(self contents asString sameAs: wording) ifTrue:[^self].
	self subMenu ifNotNil:[^self subMenu itemWithWording: wording].
	^nil! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2012 10:12'!
keyAtNonIdentityValue: value

	^ self keyAtNonIdentityValue: value ifAbsent: [self errorValueNotFound]! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2012 10:11'!
keyAtNonIdentityValue: value ifAbsent: exceptionBlock

	self associationsDo: 
		[:association | value = association value ifTrue: [^association key]].
	^exceptionBlock value! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
label: aStringOrMessageSend

	self removeAllMorphs.
	self addMorph: ((self morphForLabel: aStringOrMessageSend) 
						borderWidth: 1;
						margins: 2;
						centered;
						autoFit: true;
						backgroundColor: (Color thistle muchLighter alpha: 0.9); 
						center: self bounds bottomCenter)! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:16'!
label: aString
	label := aString! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
lambdaParseArgumentFor: aSelector inBehalfOf: anObject withString: aString initialAnswer: stringOrSymbol then: cSelector

	| str |

	aSelector ifNil: [^ self].

	str := FillInTheBlank request: aString 
			initialAnswer: 
				(stringOrSymbol isSymbol 
					ifTrue: [(anObject perform: stringOrSymbol) printString] 					ifFalse: [stringOrSymbol]) .
	str ifEmpty: [^ self].

	anObject perform: aSelector withArguments: {Lambda parse: str}.
	cSelector isSymbol
		ifTrue: [defaultTarget perform: cSelector]
		ifFalse: [cSelector value] 
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/29/2012 21:37'!
lastLine

	^ self lineCorrespondingToIndex: self size! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
leftCenter: aPoint

	self center: aPoint.
	self left: aPoint x! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
lines

	^ self linesCollect: [:line | line]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
linesCollect: aBlock
	"execute aBlock with each line in this string.  The terminating CR's are not included in what is passed to aBlock"
	| start end collection |
	start := 1.
	collection := OrderedCollection new.
	[ start <= self size ] whileTrue: [
		end := self indexOf: Character cr  startingAt: start  ifAbsent: [ self size + 1 ].
		end := end - 1.

		collection add: (aBlock value: (self copyFrom: start  to: end)).
		start := end + 2. ].

	^ collection asArray! !

!InteractiveMorphOperator methodsFor: 'as yet unclassified' stamp: 'spfa 3/9/2010 14:15'!
lms: aLambdaMessageSend

	lms := aLambdaMessageSend.
	balloonText := aLambdaMessageSend printString.
	self smallLabel: aLambdaMessageSend printString.
	self receiver: lms compiled selector: #value:.! !

!PBBooleanPreferenceView methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 4/16/2010 19:21'!
localToProjectButton
	| aButton aLabel psel |

	psel := self preference dictionarySymbol.

	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: (Preferences lambda preferenceAt: psel);
		actionSelector: #toggleProjectLocalness;
		getSelector: #localToProject;
		yourself.
	aLabel := (StringMorph contents: 'local' translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).		
	^self horizontalPanel
		addMorphBack: aButton;
		addMorphBack: aLabel;
		yourself.! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 22:22'!
lockDirectory

	self getProperty: #lockDirectory! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 22:22'!
lockFileName

	self getProperty: #lockFileName! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
makeGetterSetterWordingFrom: anAssociation

	anAssociation value ifNil: [^ anAssociation key].

	anAssociation key ifEmpty: [^ anAssociation value value stringForMenu].

	^ anAssociation key, ': ', anAssociation value value stringForMenu! !

!MouseInputArea class methodsFor: 'utilities' stamp: 'spfa 2/11/2014 12:14'!
makeHalo: aRectangle with: anArrayOfAssociations color: aColor

	anArrayOfAssociations 
	with: 
	({	 #bottomRight: -> #topLeft.
	 	 #bottomLeft: -> #topRight.
	      #topRight: -> #bottomLeft.
	 	 #topLeft: -> #bottomRight} first: anArrayOfAssociations size) 
	do: 
	[:assoc :cop |
		self new
			beTemporary; beSmall; 
			perform: cop key with: (aRectangle perform: cop value);
			messageSend: assoc value;
			smallLabel: assoc key;
			borderColor: aColor;
			openInWorld]


			
	! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 11/18/2009 18:09'!
makeHaloTargetting: aMorph withSelectors: anArrayOfAssociations color: aColor

	self makeHalo: aMorph bounds
		with: (anArrayOfAssociations
				collect: [:a | a key -> (aMorph lambda: a value)])
		color: aColor 


! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
makeLambdaFrom: aSymbolOrLambda

	aSymbolOrLambda ifNil: [^ nil].

	 aSymbolOrLambda isSymbol 
		ifTrue: [^ defaultTarget lambda: aSymbolOrLambda].

	aSymbolOrLambda isMessageSend ifFalse: [self error: 'unproper object'].

	^ aSymbolOrLambda asLambdaMessageSend! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/25/2012 23:15'!
maxFirst: n
	"Answer the first n elements of the receiver.
	Do not raise an error if there are not enough elements, just return what we got."

	self ifEmpty: [^ #()].

	^ self copyFrom: 1 to: (n min: self size)! !

!LimitedSharedQueue methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2010 22:47'!
maxSize: anInteger

	maxSize := anInteger! !

!UpdatingStringMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
maximumWidth: aNumber

	maximumWidth := aNumber! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/27/2011 16:48'!
mean

	^ self average! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 23:56'!
menu

	^ (MenuMorph new defaultTarget: self)
		add: 'keep file name' toggleForProperty: #lockFileName;
		add: 'increment file name' toggleForProperty: #lockRootFileName;
		add: 'keep directory' toggleForProperty: #lockDirectory;
		add: 'browse directory' action: #browseDirectory;
		title: 'MIDI file dumper'! !

!MenuSliderItemMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2013 23:17'!
menuSliderColor
	<preference: 'In-menu Sliders Color'
		category: 'colors'
		description: 'Governs the color of sliders in menu items'
		type: #Color>
	^ MenuSliderColor ifNil: [Preferences menuTitleColor]! !

!MenuSliderItemMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2013 23:18'!
menuSliderColor: aColor

	MenuSliderColor := aColor! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2010 22:36'!
menuWithLambda: aBlock

	| m |
	
	m := MenuMorph new defaultTarget: self.

	self isEmpty ifTrue: [^ m add: '<nothing here>' action: #yourself].

	self keysAndValuesDo: [:k :v |
		v isDictionary ifTrue: [m add: k dynamicSubMenu: (v lambda menuWithLambda: aBlock)]
			ifFalse: [m add: k lambda: (aBlock value: v)]].
		
	^ m! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
messageSend: aMessageSend

	messageSend := aMessageSend! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/8/2010 13:39'!
methodsOf: aClass inCategories: anArray build: aBlock

	(anArray select: [:cat | 
		(aClass organization listAtCategoryNamed:  cat) notEmpty])
	do: [:cat | | catm |
		catm := MenuMorph new.
		(aClass organization listAtCategoryNamed:  cat) do: [:sel |
			aBlock value: catm value: sel].
		self add: cat subMenu: catm].

		! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2010 09:31'!
middle

	^ (self start + self end) * 0.5! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/17/2010 11:02'!
mod2Pi

	 ^ self modTurn
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 2/24/2012 17:55'!
modHalfTurn

	 ^ self \\ Float halfTurn
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 2/24/2012 17:55'!
modPi

	 ^ self modHalfTurn
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/13/2010 13:19'!
modTurn

	 ^ self \\ Float turn
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
moduleIn: anInterval

	| xt x|

	x := self.
	xt := anInterval extent.
	x > anInterval last ifTrue: [xt := xt negated].
	[anInterval rangeIncludes: x]
		whileFalse: [x := x + xt].
	^ x 

	! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
morphForLabel: aStringOrMessageSend

	^ aStringOrMessageSend isString
		ifTrue: [TextMorph new 
					contents: aStringOrMessageSend asBoldText;
					color: Color darkGray]
		ifFalse: [UpdatingTextMorph on: aStringOrMessageSend]
	! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:09'!
mouseDown: evt
	"Wait for a double-click"
	evt hand waitForClicksOrDrag: self event: evt.

	^super mouseDown: evt
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/12/2010 16:33'!
mouseEnter: evt
	"The mouse entered the receiver"

	owner ifNotNil: [self mouseEnterDragging: evt ]! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:16'!
mouseEnter: evt

	self flash.
	messageSend value.
	self temporary ifTrue: [0.1 exactSeconds asDelay wait. self delete].
! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 19:56'!
mouseEnter: evt

	self color: (self color adjustBrightness: -0.1).
	self startStepping! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 19:57'!
mouseLeave: evt

	self color: self inactiveColor.

	! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:17'!
mouseUp: evt
	"Allow on:send:to: to set the response to events other than actWhen"
	actWhen == #buttonUp ifFalse: [^super mouseUp: evt].

	(self containsPoint: evt cursorPoint) ifTrue: [
		self state: #on.
		self doButtonAction: evt
	] ifFalse: [
		self state: #off.
		target ifNotNil: [target lambdaValue mouseUpBalk: evt]
	].
	"Allow owner to keep it selected for radio buttons"
! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 4/4/2010 14:49'!
negativeFlag

	^ self >= 0 ifTrue: [0] ifFalse: [1]! !

!LimitedSharedQueue class methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2010 22:47'!
new: anInteger

	^ (super new: anInteger) maxSize: anInteger! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/17/2013 09:59'!
newColumn: anArray

	| column |
	
	column := self new layoutPolicy: ProportionalLayout new.
	anArray doWithIndex: [:morph :i |
		column addMorph: morph fullFrame: 
			(LayoutFrame fractions: 
				(0@((1 /// anArray size) * (i - 1)) corner: 1@((1 /// anArray size) * i)))].
		
	^ column! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2011 12:02'!
newDisplayToUser

	^ self new displayToUser! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 22:55'!
newFile

	| def |

	((self hasProperty: #lockFileName)
		and: [lastFile notNil])
		ifTrue: [^ lastFile].

	((self hasProperty: #lockRootFileName)
		and: [lastFile notNil])
		ifTrue: [^ lastFile nextFile].

	def := lastFile ifNil: [''] ifNotNil: [lastFile nextFile localName].

	(self hasProperty: #lockDirectory) ifTrue: 
		[^ FileReference query: 'MIDI file name' inDirectory: directory default: def].

	^ FileReference query: 'MIDI file name' directory: directory default: def! !

!Browser class methodsFor: '*People-spfa-utils' stamp: 'spfa 4/3/2014 22:21'!
newOnClass: aClass category: aSymbol
	"Open a new class browser on this class."
	| newBrowser |

	newBrowser := self new.
	newBrowser setClass: aClass selector: nil.
	newBrowser selectMessageCategoryNamed: aSymbol.
	^ self 
		openBrowserView: (newBrowser openOnClassWithEditString: nil)
		label: 'Class Browser: ', aClass name
! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
newOpenInHand

	^ self new openInHand! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/17/2013 09:59'!
newRow: anArray

	| column |
	
	column := self new layoutPolicy: ProportionalLayout new.
	anArray doWithIndex: [:morph :i |
		column addMorph: morph fullFrame: 
			(LayoutFrame fractions: 
				(((1 /// anArray size) * (i - 1))@0 corner: ((1 /// anArray size) * i)@1))].
		
	^ column! !

!CollapsedMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
newSansCloseBox

	^ (self basicNew) wantsCloseBox: false; initialize
	
! !

!PositionableStream methodsFor: '*People-spfa-utils' stamp: 'spfa 1/14/2012 14:28'!
next
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	position >= readLimit
		ifTrue: [^nil]
		ifFalse: [^collection at: (position := position + 1)]! !

!Object methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 2/17/2014 14:08'!
nextIfAny

	^ self ! !

!Stream methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 2/17/2014 14:08'!
nextIfAny

	^ self next! !

!LimitedSharedQueue methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2010 22:48'!
nextPut: anObject

	super nextPut: anObject.
	self size > maxSize ifTrue: [self next]! !

!Random methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
nextWithin: anInterval
	"Answer a random number in the specified interval"

	^ (self next * anInterval width) + anInterval ordered start! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
noWeakTarget

	"binding the target in extension ensure that it is never weakly copied"

	self setProperty: #noWeakTarget toValue: target
	! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
nonEmptylines

	^ self findBetween: Character cr
! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 7/31/2010 21:35'!
nonTransitiveKeyAt: anObject

	^ ((self keysAtValue: anObject) ifEmpty: [^ nil]) detect: [:s | (self includesKey: (self at: s)) not]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 6/10/2010 15:48'!
nonTransitiveKeys

	^ self keys reject: [:s | self includesKey: (self at: s)]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 1/6/2011 20:10'!
nonTransitiveSynonymOf: anObject

	^ (self nonTransitiveKeyAt: anObject) ifNil: [anObject]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 10/1/2010 14:41'!
nonTransitiveValues

	^ self values reject: [:s | self includesKey: s]! !

!SystemWindow class methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/18/2009 18:17'!
noteTopWindowIn: aWorld
	| newTop |
	"TopWindow must be nil or point to the top window in this project."
	TopWindow := nil.
	aWorld ifNil: [^ self].
	newTop := nil.
	aWorld submorphsDo:
		[:m | (m isSystemWindow and: [m isCollapsed not]) ifTrue:
			[(newTop == nil and: [m activeOnlyOnTop])
				ifTrue: [newTop := m].
			(m model isKindOf: Project)
				ifTrue: ["This really belongs in a special ProjWindow class"
						m label ~= m model name ifTrue: [m setLabel: m model name]]]].
	newTop == nil ifFalse: [newTop activate]! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 6/20/2012 15:03'!
occurrencesOfAnyOf: aCollection 
	"Answer how many of the receiver's elements are members of aCollection."

	| tally |
	tally := 0.
	self do: [:each | (aCollection includes: each) ifTrue: [tally := tally + 1]].
	^tally! !

!SystemWindow methodsFor: '*People-spfa-utils-override' stamp: 'spfa 9/29/2012 09:54'!
offerWindowMenu
	| aMenu |
	aMenu := (model isNil or: [model wantsUsualWindowMenu])
		ifTrue: [self buildWindowMenu]
		ifFalse: [MenuMorph new defaultTarget: self].
	model ifNotNil:
		[model addModelItemsToWindowMenu: aMenu].
	aMenu popUpEvent: self currentEvent in: self world! !

!UpdatingTextMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
on: aMessageSend

	^ self on: aMessageSend receiver selector: aMessageSend selector ! !

!UpdatingTextMorph class methodsFor: 'instance creation' stamp: 'dgd 3/8/2004 20:31'!
on: targetObject selector: aSymbol 
	"answer a new instance of the receiver on a given target and selector"
	^ self new getSelector: aSymbol;
		 target: targetObject! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
onCategoriesAndMethodsOf: aClass build: aBlock

	^ self onMethodsOf: aClass inCategories: aClass organization categories build: aBlock


		! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/26/2010 13:47'!
onList: anArray build: aBlock

	| m |

	m := self new.
	anArray do: [:key | 
		m add: key lambda: (aBlock value: key)].

	^ m
		! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
onMethodsOf: aClass inCategories: anArray build: aBlock

	| m |

	m := self new.

	(anArray select: [:cat | 
		(aClass organization listAtCategoryNamed:  cat) notEmpty])
	do: [:cat | | catm |
		catm := self new.
		(aClass organization listAtCategoryNamed:  cat) do: [:sel |
			aBlock value: catm value: sel].
		m add: cat subMenu: catm].

	^ m
		! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
openB64InWorkspace

	"'SGkgVGhlcmUh' openB64InWorkspace"

	self fromB64 displayWithLabel: 'code'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2011 12:19'!
openCopyInHand

	self veryDeepCopy displayToUser! !

!Morph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/18/2009 18:13'!
openInHand
	"Attach the receiver to the current hand in the current morphic world"

	self formerOwner ifNil: [self formerOwner: World].
	self currentHand attachMorph: self! !

!SimpleMIDIPort class methodsFor: '*People-spfa-utils' stamp: 'spfa 2/26/2010 13:30'!
openInMatching: aString

	| portCount dir |
	portCount := self primPortCount.
	portCount = 0 ifTrue: [^ nil].
	0 to: portCount - 1 do:[:i |
		dir := self primPortDirectionalityOf: i.
		(((dir = 1) | (dir = 3))
			and: [aString match: (self portDescription: i)]) 
		ifTrue: [^ self openOnPortNumber: i]].
			
	^ nil! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/22/2014 21:16'!
openInWorkspaceWithTitle: aTitle
	"Open up a workspace with the receiver as its contents, with the given title"

	(Workspace new contents: self) openLabel: aTitle! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
openInWorkspaceWithTitle: aTitle
	"Open up a workspace with the receiver as its contents, with the given title"

	(Workspace new contents: self) openLabel: aTitle! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
openNearHand

	(self bottomRight: (self currentHand position - (10@10))) openInWorld! !

!SimpleMIDIPort class methodsFor: '*People-spfa-utils' stamp: 'spfa 2/26/2010 13:30'!
openOutMatching: aString

	| portCount dir |
	portCount := self primPortCount.
	portCount = 0 ifTrue: [^ nil].
	0 to: portCount - 1 do:[:i |
		dir := self primPortDirectionalityOf: i.
		(((dir = 2) | (dir = 3))
			and: [aString match: (self portDescription: i)]) 
		ifTrue: [^ self openOnPortNumber: i]].
			
	^ nil! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/9/2010 17:58'!
orMoreDo: aBlock

	self do: aBlock! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 12/9/2010 17:56'!
orMoreDo: aBlock

	^ aBlock value: self! !

!Symbol methodsFor: '*People-spfa-utils' stamp: 'spfa 12/9/2010 18:22'!
orMoreDo: aBlock

	^ aBlock value: self! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
ordered

	start > stop ifTrue: [^ stop to: start by: step negated]! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 9/28/2011 23:32'!
orderlyIncludesAllOf: aString

	| iref |
	
	iref := 0.

	aString do: [:c |
		| i |
		i := self indexOf: c startingAt: iref ifAbsent: [^ false].
		iref := i].
	
	^ true
	! !

!SystemWindow methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/18/2009 18:17'!
paneColor
	| cc |
	(cc := self valueOfProperty: #paneColor) ifNotNil: [^cc].
	Display depth > 2 
		ifTrue: 
			[model ifNotNil: 
					[model isInMemory 
						ifTrue: 
							[cc := Color colorFrom: model defaultBackgroundColor.
							Preferences alternativeWindowLook 
								ifTrue: 
									[cc := (cc = Color lightYellow or: [cc = Color white]) 
										ifTrue: [Color gray: 0.67]
										ifFalse: [cc asColor duller]]]].
			cc 
				ifNil: [cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color]]].
	cc ifNil: [cc := self defaultBackgroundColor].
	self paneColor: cc.
	^cc! !

!LimitedSharedQueue methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2010 22:51'!
peekAll

	^ Array streamContents: [:str |
		1 to: (self size min: maxSize) do: [:n |
			self nextPut: (str nextPut: self next)]]
! !

!PositionableStream methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2011 00:14'!
peekBackOrNil

	position isZero ifTrue: [^ nil].
	self position = 0 ifTrue: [self errorCantGoBack].
	self skip: -1.
	^ self next! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 10/7/2011 20:30'!
penultimate
	"Answer the second last element of the receiver"

	^ self at: self size - 1! !

!Integer methodsFor: '*People-spfa-utils' stamp: 'spfa 6/22/2012 10:46'!
pluralString

	self > 1 ifTrue: [^ 's'].
	^ ''! !

!DockingBarMenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/9/2010 10:20'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem 
	"Present this menu at the given point under control of the given  
	hand."
	| tryToPlace selectedOffset |
	hand world startSteppingSubmorphsOf: self.
	popUpOwner := sourceItem.
	self fullBounds.
self updateColor.
	"ensure layout is current"
	selectedOffset := (selectedItem
				ifNil: [self items first]) position - self position.
	tryToPlace := [:where :mustFit | | delta | 
			self position: where - selectedOffset.
			delta := self fullBoundsInWorld amountToTranslateWithin: sourceItem worldBounds.
			(delta x = 0
					or: [mustFit])
				ifTrue: [delta = (0 @ 0)
						ifFalse: [self position: self position + delta].
					sourceItem owner owner addMorphFront: self.
					^ self]].
	tryToPlace value: rightOrLeftPoint first value: false;
		 value: rightOrLeftPoint last - (self width @ 0) value: false;
		 value: rightOrLeftPoint first value: true
! !

!DockingBarMenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/20/2010 11:52'!
popUpOwner

	^ nil! !

!DockingBarMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/20/2010 12:18'!
popUpOwner

	^ nil! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 4/4/2010 14:49'!
positiveFlag

	^ self >= 0 ifTrue: [1] ifFalse: [0]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
possibleFileName

	^ ('a ', self class name) asFileName! !

!SystemWindow methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
possibleFileName

	^ self label asFileName
	! !

!Rectangle class methodsFor: '*People-spfa-utils' stamp: 'spfa 2/11/2012 18:31'!
preciseCenter: centerPoint extent: extentPoint 
	"Answer an instance of me whose center is centerPoint and width 
	by height is extentPoint.  "

	^self origin: centerPoint - (extentPoint /// 2) extent: extentPoint! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
preciseExtent

	^ (self valueOfProperty: #preciseExtent) ifNil: [self extent]
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
precisePosition

	^ (self valueOfProperty: #precisePosition) ifNil: [self position]! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/4/2011 14:11'!
preciselyScaleFrom: rect1 to: rect2
	"Produce a point stretched according to the stretch from rect1 to rect2, and do not convert numbers to Integer"
	^ rect2 topLeft + (((x-rect1 left) * rect2 width /// rect1 width)
					@ ((y-rect1 top) * rect2 height /// rect1 height))! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
preciselyScaleFrom: rect1 to: rect2
	"Produce a rectangle stretched according to the stretch from rect1 to rect2"
	^ (origin preciselyScaleFrom: rect1 to: rect2)
		corner: (corner preciselyScaleFrom: rect1 to: rect2)! !

!PBPreferenceButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:15'!
preference
	^preference lambdaValue! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
prepareToBeSaved

	self actualSubMenu: nil! !

!Array methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:34'!
prettyPrintElementsOn: aStream

	self isLiteral ifTrue: [^ self printBareElementsOn: aStream].

	self storeOn: aStream! !

!Array methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:13'!
prettyStoreOn: aStream

	self isLiteral ifTrue: [^ self printAsBareLiteralFormOn: aStream].

	self storeOn: aStream! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:12'!
prettyStoreOn: aStream

	self storeOn: aStream! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:12'!
prettyStoreString
	"Answer a String representation of the receiver from which the receiver 
	can be reconstructed, but try to make it pleasantly human-readable when possible."

	^ String streamContents: [:str | self prettyStoreOn: str]! !

!Array methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:03'!
printAsBareLiteralFormOn: aStream
	aStream nextPut: $#.
	self printBareElementsOn: aStream
! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2013 14:24'!
printBareElementsOn: aStream

	aStream nextPut: $(.
	self do: [:element | 
		element isArray 
			ifTrue: [element printBareElementsOn: aStream]
			ifFalse: [element barePrintOn: aStream]] separatedBy: [aStream space].
	aStream nextPut: $)! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/26/2012 11:41'!
printElementsStringsOn: aStream

	aStream nextPut: $(.
	self do: [:element | aStream nextPutAll: element asString] separatedBy: [aStream space].
	aStream nextPut: $)! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
printStringUpTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString := String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...'! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
profile

	^ TimeProfileBrowser spyOn: self! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
profile

	^ TimeProfileBrowser spyOn: self! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
profileDisplay

	| canvas |

	canvas := FormCanvas extent: self extent.
	[self drawOn: canvas] profile! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:16'!
provider: anObject
	provider := anObject! !

!Float class methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/13/2010 13:29'!
quarterTurn

	"http://tauday.com
	http://en.wikipedia.org/wiki/Turn:=%28geometry%29"

	^ Halfpi! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/13/2013 14:09'!
queryArgumentFor: aSelector inBehalfOf: anObject withString: aString initialAnswer: stringOrSymbol then: cSelector

	| str |

	aSelector ifNil: [^ self].

	str := FillInTheBlank request: aString 
			initialAnswer: 
				(stringOrSymbol isSymbol 
					ifTrue: [(anObject perform: stringOrSymbol) prettyStoreString] 					ifFalse: [stringOrSymbol]) .
	str ifEmpty: [^ self].

	anObject perform: aSelector withArguments: {Compiler evaluate: str}.
	cSelector isSymbol
		ifTrue: [defaultTarget perform: cSelector]
		ifFalse: [cSelector value] 
! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
queryMorph: aString target: anObject selector: aSelector 

"
	Utilities queryMorph: 'explore what ?' 
		target: ObjectExplorer new 
		selector: #openExplorerFor:
"

	(DropReporter sendMorphTo: anObject via: aSelector)
		label: aString; openInHand
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
queryMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda initialMorphicLambda: initialMorphicLambda morphDependents: anArray thenDo: lastLambda

	| o |

	o := GenericInputMorph request: aString 
			initialAnswer: iLambda lambdaValue asString
			initialMorphicLambda: initialMorphicLambda
			morphDependents: anArray.

	o isString ifTrue:
	[ 
		o ifEmpty: [^ self].
		o := Compiler evaluate: o
	].

	aLambdaExpression withUnlimitedEvaluation valueWithArguments: {o}.
	lastLambda value

! !

!Project class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
queryProject

	| selection nBack prev |
	
	selection := (Project buildJumpToMenu: CustomMenu new) startUpLeftFlush.

	selection ifNil: [^ nil].
	(selection beginsWith: '%back') ifTrue:
		[nBack := (selection copyFrom: 6 to: selection size) asNumber.
		prev := CurrentProject previousProject.
		1 to: nBack-1 do:
			[:i | prev ifNotNil: [prev := prev previousProject]].
		prev ifNotNil: [^ prev]].
	selection = #parent ifTrue:
		[^ CurrentProject parent].
	^ Project namedWithDepth: selection.
! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:17'!
queryValue: aString proposed: aDefault format: aSymbol

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	when the string is empty, it defaults to aDefault

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [aDefault asString]) perform: aSymbol! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:17'!
queryValue: aString proposed: aDefault format: aSymbol ifNoAnswer: aBlock

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	except when the string is empty: aBlock value is then returned

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [^ aBlock value]) perform: aSymbol! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:17'!
queryValueOrCancel: aString proposed: aDefault format: aSymbol

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	when the string is empty return nil"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [^ nil]) perform: aSymbol! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
r: rho theta: theta
	"Answer an instance of me with polar coordinates rho and theta."

	^self new setR: rho radians: theta! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
radiansToMIDI: angle

	^ (self scaleFromAngle: angle to: (0 to: 127)) rounded! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 11/18/2009 18:10'!
raisedToInteger: exp modulo: m
	(exp = 0) ifTrue: [^ 1].
	exp even
		ifTrue: [^ (self raisedToInteger: (exp // 2) modulo: m) squared \\ m]
		ifFalse: [^ (self * (self raisedToInteger: (exp - 1) modulo: m)) \\ m].! !

!Fraction class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
readFrom: stringOrStream 
	| num den  aStream  |
	den := 1.
	aStream := (stringOrStream isString)
		ifTrue: [ReadStream on: stringOrStream]
		ifFalse: [stringOrStream].
	aStream peekFor: $(.
	num :=Integer readFrom: aStream base: 10.
	(aStream peekFor: $/) 
		ifTrue: [den :=Integer readFrom: aStream base: 10].
	^ Fraction numerator: num denominator: den

	! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 4/16/2010 15:46'!
readFromFile: fileName

 	^ (MultiByteBinaryOrTextStream with: 
		((FileStream readOnlyFileNamed: fileName) binary contentsOfEntireFile))
		binary reset fileInObjectAndCode! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 4/16/2010 16:03'!
readFromLocalFile: aString

 	^ self readFromFile: (FileDirectory default fullNameFor: aString)
! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
receiver: anObject selector: aSelector

	messageSend := MessageSend receiver: anObject selector: aSelector! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 4/1/2012 21:12'!
relativeValueOf: aNumber

	self width isZero ifTrue: [^ 0].

	^ (aNumber - (self start min: self end)) /// self width! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 12/4/2012 17:54'!
removeKeyAtValue: anObject

	self removeKey: (self keyAtValue: anObject ifAbsent: [^ self]).! !

!SystemWindow methodsFor: '*People-spfa-utils' stamp: 'spfa 9/4/2014 16:33'!
removePane: aMorph

	aMorph delete.
	paneMorphs := paneMorphs copyWithout: aMorph.
	updatablePanes := updatablePanes copyWithout: aMorph ! !

!ClassDescription methodsFor: '*people-spfa-utils' stamp: 'spfa 4/4/2012 10:29'!
removeSelectorSilently: selector 	
	
	SystemChangeNotifier uniqueInstance doSilently: [
		self organization removeElement: selector]
! !

!Generator class methodsFor: '*people-spfa-utils' stamp: 'spfa 5/11/2010 21:35'!
repeat: aBlock
	^ self on: [:g | [g yield: aBlock value] repeat].
! !

!MessageTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
reportSpyOn: aBlock 
	| node report |
	node := self new.
	node spyEvery: self defaultPollPeriod on: aBlock.
	report := node tally isZero 
				ifTrue:[''] 
				ifFalse: [String streamContents: [:s | node report: s; close]].
	^ report! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:17'!
request: aString

	"
Utilities request: 'What do you think ?'
"

	^ self request: aString initialAnswer: '


' ! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:17'!
request: aString initialAnswer: bString 

	"fast replacement for FillInTheBlank similar method. Got tired of the tiny window..."

	| w h |

	w := 500.
	h := ((bString lineCount + 2)* TextStyle defaultFont height) min: 300.

	^ (FillInTheBlankMorph
		 	request: aString
 			initialAnswer: bString
			centerAt: ActiveHand cursorPoint 
			inWorld: World 
			onCancelReturn: '' 
			acceptOnCR: false 
			answerExtent: w @ h) whenEmpty: [^ '']! !

!StrongButtonMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 3/26/2013 18:09'!
restoreNotebookButtonsColor

	"StrongButtonMorph restoreNotebookButtonsColor"

	self allInstances do: [:ea |
		| notebookStatus |
		(notebookStatus := ea valueOfProperty: #status) ifNotNil: [
			ea baseColor: (Notebook buttonColor: notebookStatus)]]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
reverseDetect: aBlock 

	^ self reverseDetect: aBlock ifNone: [self errorNotFound: aBlock]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
reverseDetect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument, starting with the last element and proceeding backwards.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self reverseDo: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!OrderedCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/19/2012 00:15'!
reverseDoWithIndex: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index) value: (index := index - 1)]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/19/2012 00:15'!
reverseDoWithIndex: aBlock

	self size to: 1 by: -1 do: [:index | aBlock value: (self at: index) value: index]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'ul 4/11/2011 03:07'!
reverseInPlace
	"Reverse this collection in place."
	
	| start end |
	start := 1.
	end := self size.
	[ start < end ] whileTrue: [
		| temp |
		temp := self at: start.
		self
			at: start put: (self at: end);
			at: end put: temp.
		start := start + 1.
		end := end - 1 ]
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
rightCenter: aPoint

	self center: aPoint.
	self right: aPoint x! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
ripApart

	self delete.
! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
ripApart

	self delete.
	self stopSteppingSelfAndSubmorphs.
	self submorphs do: [:m | m ripApart]! !

!SequenceableCollection methodsFor: '*People-spfa-utils-base1' stamp: 'spfa 12/13/2010 15:22'!
rotatedBy: aNumber

	self isEmpty ifTrue: [^ self].
	^ (1 to: self size) collect: [:i | self atWrap: i + aNumber]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/14/2010 21:44'!
rotations

	^ (0 to: self size - 1) collect:  [:n | self rotatedBy: n] ! !

!TestSuite methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
run: aResult 
	self run: aResult withProgress: name
			! !

!TestSuite methodsFor: '*People-spfa-utils' stamp: 'spfa 4/19/2010 14:18'!
run: aResult withProgress: aString

	self tests ifEmpty: [^ self].

	self tests do: [:each | 
		self changed: each.
		each run: aResult] displayingProgress: (aString ifNil: [self tests anyOne class name])
			! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/28/2010 15:56'!
save: aMGraphElement

	lastFile := (self newFile ifNil: [^ self]) withExtension: 'mid'.
	directory := lastFile directory.

	(aMGraphElement treeValue asMusicalPhrase 
		asMIDIFileNamed: lastFile) openAsBox.

	self smallLabel: lastFile directory pathParts last! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/9/2010 17:47'!
saveOnFile: aFileName

	|  fileStream |

	fileStream := FileStream fileNamed: aFileName.											
	self allMorphsDo: [:m | m prepareToBeSaved].
	fileStream fileOutClass: nil andObject: self.! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
saveOnFileRememberWhere

	| aFileName fileStream ok |

	self hasUsualFile
		ifTrue: [aFileName := self usualFile]
		ifFalse: [aFileName := self defaultFileName].

	aFileName := FillInTheBlank 
			request: ('File name for ', (self knownName ifNil:[self name]) , ' ?' )
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self].

	self allMorphsDo: [:m | m prepareToBeSaved].

	ok := aFileName endsWith: '.morph'.	"don't double them"
	ok := ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName := aFileName,'.morph'].

	self usualFile: aFileName.

	fileStream := FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/4/2013 14:06'!
saveOnUsualFile

	|  fileStream |

	self hasUsualFile ifFalse: [^ self saveOnFileRememberWhere].
	
	FileDirectory default deleteFileNamed: self usualFile.
	
	fileStream := FileStream fileNamed: self usualFile.					
	fileStream ifNil: [^ self saveOnFileRememberWhere].
						
	self allMorphsDo: [:m | m prepareToBeSaved].
	fileStream fileOutClass: nil andObject: self.! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 3/21/2013 22:18'!
scaleFrom: anInterval to: anotherInterval

	^ (anotherInterval extent * ((self forceIn: anInterval) - anInterval first) /// anInterval extent) + anotherInterval first! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/13/2010 13:20'!
scaleFromAngle: aNumber to: anInterval

	| intv |

	intv := aNumber to: (aNumber + Float turn).

	^ (self moduleIn: intv) scaleFrom: intv to: anInterval! !

!PluggableTextMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/18/2013 13:51'!
scrollBar

	^ scrollBar! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 1/24/2013 15:35'!
segments

	^ Array streamContents: [:str | 
		self segmentsDo: [:ea1 :ea2 |
			str nextPut: {ea1 . ea2}]]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
segmentsCollect: aBlock 
	"Evaluate aBlock with my elements taken two at a time: each element with its immediate follower. See also segmentsDo:"

	^ (1 to: self size - 1) collect:
		[:index | aBlock value: (self at: index) value: (self at: index + 1)]
! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
segmentsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time: each element with its immediate follower. See also segmentsCollect:"

	1 to: (self size - 1) do:
		[:index | aBlock value: (self at: index) value: (self at: index + 1)]
! !

!DockingBarItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 9/9/2010 10:28'!
select: evt
	
	self isSelected: true.
	owner activeSubmenu: subMenu.
	subMenu ifNotNil: [
		subMenu delete.
		subMenu
			popUpAdjacentTo: self adjacentTo
			forHand: evt hand
			from: self.
		subMenu selectItem: nil event: evt].

	subMenu ifNotNil: [
		evt hand newKeyboardFocus: subMenu ].
	
	self addAlarm: #deselectTimeOut at: Time primMillisecondClock + 300! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 4/18/2011 00:03'!
select: evt

	self isSelected: true.
	self actualSubMenu ifNotNil: [self deleteSubMenu].
	owner activeSubmenu: self subMenu.
	self subMenu ifNotNil: [
		self subMenu
			popUpAdjacentTo: 
				(Array with: self fullBoundsInWorld topRight + (7@0)
						with: self fullBoundsInWorld topLeft)
			forHand: evt hand
			from: self.
		self subMenu selectItem: nil event: evt].
	self addAlarm: #deselectTimeOut at: Time primMillisecondClock + 300! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 5/20/2010 14:37'!
selectWithIndex: elementAndIndexBlock

	^ self species streamContents: [:str |
		self withIndexDo: [:ea :index |
			(elementAndIndexBlock
				value: ea
				value: index) ifTrue: [str nextPut: ea]]]! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:16'!
selector: aSelector
	selector := aSelector! !

!DropReporter class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:09'!
sendMorphTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!MIDIFileDumperMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 21:59'!
sendPassengerTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!TransferGetter class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:17'!
sendPassengerTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
sendToAnotherProject

	| target |
	
	target := Project queryProject ifNil: [^ self].
	target world addMorph: self! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/5/2010 16:05'!
setLabelWidgetAllowance

	self wantsCloseBox ifTrue: [^ super setLabelWidgetAllowance].

	^ labelWidgetAllowance :=  (self boxExtent x * 3) + 19! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/6/2010 22:06'!
setProperty: aSymbol toValue: anObject then: bSymbol

	self setProperty: aSymbol
		  toValue: anObject.

	bSymbol isSymbol ifTrue: [^self perform: bSymbol].
	bSymbol value.
					! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
setX: aValue
	x := aValue
! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
setXY: aPoint

	x := aPoint x.
	y := aPoint y! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
setY: aValue
	y := aValue
! !

!Random methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
sign
	"Answer 1 or -1"

	^ (self nextWithin: (-10 to: 10)) sign! !

!PositionableStream methodsFor: '*People-spfa-utils' stamp: 'spfa 4/18/2010 22:43'!
silentlyFileIn
	
	| val chunk |

	[self atEnd] whileFalse: [
			
		self skipSeparators.
					
		[val := (self peekFor: $!!) 
			ifTrue: [
				(Compiler evaluate: self nextChunk logged: false) scanFrom: self]
			ifFalse: [
				chunk := self nextChunk.
				self checkForPreamble: chunk.
				Compiler evaluate: chunk logged: true]] 
		on: InMidstOfFileinNotification
		do: [:ex | ex resume: true].

		self skipStyleChunk].

	self close.
	"Note:  The main purpose of this banner is to flush the changes file."
	SmalltalkImage current logChange: '----End fileIn of ' , self name , '----'.
	self flag: #ThisMethodShouldNotBeThere.	"sd"
	Smalltalk forgetDoIts.
	^val! !

!ReadWriteStream methodsFor: '*People-spfa-utils' stamp: 'spfa 4/18/2010 22:45'!
silentlyFileInObjectAndCode
	"This file may contain:
1) a fileIn of code  
2) just an object in SmartReferenceStream format 
3) both code and an object.
	File it in and return the object.  Note that self must be a FileStream or RWBinaryOrTextStream.  Maybe ReadWriteStream incorporate RWBinaryOrTextStream?"
	| refStream object |
	self text.
	self peek asciiValue = 4
		ifTrue: [  "pure object file"
			refStream := SmartRefStream on: self.
			object := refStream nextAndClose]
		ifFalse: [  "objects mixed with a fileIn"
			self silentlyFileIn.  "reads code and objects, then closes the file"
			object := SmartRefStream scannedObject].	"set by side effect of one of the chunks"
	SmartRefStream scannedObject: nil.  "clear scannedObject"
	^ object! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
skip: aCharacter from: start 
	"Answer the index of the character within the receiver, starting at start, that does NOT match aCharacter. If the receiver does not contain any aCharacter answer size + 1. "

	start to: self size do: [:i | aCharacter = (self at: i) ifFalse: [^ i]].
	^ self size + 1! !

!PositionableStream methodsFor: '*People-spfa-utils' stamp: 'spfa 5/31/2011 09:20'!
skipBlanks
	[self atEnd]
		whileFalse:
		[self next isBlank ifFalse: [^ self position: self position-1]]! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 23:37'!
smallLabel: aString

	super smallLabel: aString.
	self addMenu! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 11/18/2009 18:13'!
smallLabel: aStringOrMessageSend

	self removeAllMorphs.
	self addMorph: ((self morphForLabel: aStringOrMessageSend) 
						borderWidth: 0;
						margins: 1;
						centered;
						autoFit: true;
						backgroundColor: Color transparent; 
						center: bounds center;
						bottom: bounds bottom)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
smallThumbnailForPageSorter

	^ (BookPageThumbnailMorph new smaller) page: self! !

!ArrayedCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2012 11:30'!
sortVia: aSelector

	"Sort this collection using aSelector, which is send to each elements.
	< is used for comparison."

	^ self sort: [:b1 :b2 | (b1 perform: aSelector) < (b2 perform: aSelector)]! !

!OrderedCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2012 11:30'!
sortVia: aSelector

	"Sort this collection using aSelector, which is send to each elements.
	< is used for comparison."

	^ self sort: [:b1 :b2 | (b1 perform: aSelector) < (b2 perform: aSelector)]! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
spaceProfile

	^ SpaceTally analyseDifferenceAfter: self! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
spaceProfile

	^ SpaceTally analyseDifferenceAfter: self! !

!BlockClosure methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
spaceProfileClasses: classes

	^ SpaceTally analyseDifferenceAfter: self forClasses: classes! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
spaceProfileClasses: classes

	^ SpaceTally analyseDifferenceAfter: self forClasses: classes! !

!SpaceTally methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
spaceTally: classes progressSays: aString

	self preAllocateResultsFor: classes.
	Smalltalk garbageCollect.
	self computeSpaceUsageWithProgress: aString.
	^ results
! !

!Character class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:07'!
specialValues

	| d |

	d := IdentityDictionary new.

	{
			1 -> 'home' .
			3 -> 'enter' .
			4 -> 'end' .
			5 -> 'insert' .
			8 -> 'backspace' .
			9 -> 'tab' .
			10 -> 'linefeed'.
			11 -> 'page up' .
			12 -> 'page down' .
			13 -> 'carriage return' .
			27 -> 'escape' .
			28 -> 'arrow left' .
			29 -> 'arrow right' .
			30 -> 'arrow up' .
			31 -> 'arrow down' .
			32 -> 'space' .
			127 -> 'delete'
	}
	do: [:a | d add: a].

	^ d! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/27/2011 16:54'!
standardDeviation

	^ self variance sqrt
! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
start

	^ start! !

!EtoyUpdatingThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:09'!
step
	| newBoolean |

	state == #pressed ifTrue: [^ self].
	newBoolean := target lambdaValue perform: getSelector withArguments: arguments.
	newBoolean == self isOn
		ifFalse:
			[self state: (newBoolean ifTrue: [#on] ifFalse: [#off])]
! !

!MPEGSubtitlesDisplayer methodsFor: 'stepping and presenter' stamp: 'dgd 3/7/2004 20:59'!
step
	"update my position"
	super step.
	" 
	if my owner is the mpegplayer, i change my position to  
	bottomCenter"
	self owner == self target
		ifTrue: [| bc | 
			bc := self owner bottomCenter.
			self left: bc x - (self width // 2).
			self bottom: bc y]! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:13'!
step

	(self temporary
		and: [Time now >= (1.5 exactSeconds + (self valueOfProperty: #creationTime))])
		ifTrue: [self delete]
		
! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 19:56'!
step
	
	(self boundsInWorld containsPoint: self activeHand position ) ifTrue: [^ self].

	self color: self inactiveColor.
	self stopStepping
! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/8/2004 20:34'!
step
	"update my contents"
	| newContents |
	super step.
	""
	newContents := self contentsFromTarget.
	self visible: newContents isEmpty not.
	self contents: newContents! !

!UpdatingThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 11/18/2009 18:17'!
step
	| newBoolean |
	super step.
	state == #pressed ifTrue: [^ self].
	newBoolean := target lambdaValue perform: getSelector.
	newBoolean == self isOn
		ifFalse:
			[self state: (newBoolean == true ifTrue: [#on] ifFalse: [#off])]! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:13'!
stepTime

	^ 100
		
! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2013 18:55'!
stepTime

	^ 100

! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/7/2004 20:19'!
stepTime
	"answer the desired time between steps in milliseconds."
	^ stepTime
		ifNil: [50]! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/7/2004 20:19'!
stepTime: mSecsPerStep 
	"change the receiver's stepTime"
	stepTime := mSecsPerStep rounded! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 11/27/2011 17:52'!
stop

	^ stop! !

!NewParagraph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:14'!
storeDataOn: aDataStream

	| linesCache |

	"have an instance of TextLine always referenced in case lines do not contain one at the time of registering classes in structure"
	(linesCache := lines) isEmptyOrNil ifTrue: [lines := {TextLine new}].
	super storeDataOn: aDataStream.
	lines := linesCache! !

!TextMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
storeDataOn: aDataStream

	"have an instance of paragraphClass always referenced, else the paragraph may be lazily created at a bad moment without a reference in structure, which would lead to an error on loading back the morph"
	self setProperty: #dummy toValue: self paragraphClass new.
	super storeDataOn: aDataStream.
	self removeProperty: #dummy! !

!Array methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/13/2013 14:28'!
stringForMenu

	self isLiteral ifFalse: [^ super stringForMenu].
	
	^ self bareLiteralPrintString contractTo: 50! !

!Float methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:09'!
stringForMenu

	^ self withMenuPrecision asString! !

!Object methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:15'!
stringForMenu

	^ self printString contractTo: 30! !

!Point methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:15'!
stringForMenu

	^ self withMenuPrecision asString! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 10/1/2013 09:58'!
subCapitalized
	
	^ self species streamContents: [:result |
		| end beginning |
	
		end := 0.
		"find one substring each time through this loop"
		[ 	
			"find the beginning of the next substring"
			beginning := end+1.
			[beginning <= self size and:[(self at: beginning) isSeparator]]
				whileTrue:[beginning := beginning + 1].
			beginning <= self size] whileTrue: [
				"find the end"
				end := beginning.
				[end <= self size and:[(self at: end) isSeparator not]]
					whileTrue:[end := end + 1].
				end := end - 1.
				result nextPutAll: (self copyFrom: beginning to: end) capitalized; space
		].
	
		result skip: -1]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 9/29/2013 21:09'!
subGroupsDo: aBlock

	self ifEmpty: [^ self].
	1 to: self size do: [:n | self subGroupsOf: n do: aBlock]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 9/29/2013 21:09'!
subGroupsOf: anInteger do: aBlock 
	"Evaluate aBlock with my elements taken anInteger at a time, accounting for all offsets leading to different groupings"

	| nGroups nOffsets |
	
	self ifEmpty: [^ self].	
	
	nGroups := self size // anInteger.
	nOffsets := anInteger - 1.
	
	0 to: nOffsets do: [:o |
		0 to: nGroups-1 do:
			[:g | 
				(o + ((g + 1) * anInteger)) > self size ifFalse: [
					aBlock value: ((1 to: anInteger) collect: [:n | self at: o + (g * anInteger) + n])]]]
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
subMenu

	"subMenu may be a MessageSend, so use #lambdaValue"

	self actualSubMenu ifNil: [self actualSubMenu: subMenu lambdaValue].
	^ self actualSubMenu
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 11/18/2009 18:13'!
subMenu: aMenuMorphOrMessageSend

	subMenu := aMenuMorphOrMessageSend.
	self actualSubMenu: nil.
	self changed.
! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
substringsWithSeparators: aString
	"Answer an array of the substrings that compose the receiver."
	| result end beginning separators nonseparators |

	result := WriteStream on: (Array new: 10).

	separators := CharacterSet newFrom: aString.
	nonseparators := separators complement.

	end := 0.
	"find one substring each time through this loop"
	[ 
		"find the beginning of the next substring"
		beginning := self indexOfAnyOf: nonseparators startingAt: end+1 ifAbsent: [ nil ].
		beginning ~~ nil ] 
	whileTrue: [
		"find the end"
		end := self indexOfAnyOf: separators startingAt: beginning ifAbsent: [ self size + 1 ].
		end := end - 1.

		result nextPut: (self copyFrom: beginning to: end).

	].


	^result contents! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
substringsWithStringSeparator: aString
	"Answer an array of the substrings that compose the receiver."
	| result end beginning s |

	result := WriteStream on: (Array new: 10).

	end := 0.
	beginning := 1.
	[ 
		end := self findString: aString startingAt: beginning.
		s := self copyFrom: beginning 
								to: (end isZero ifTrue: [self size] ifFalse: [end - 1]).
		s ifNotEmpty: [result nextPut: s].
		end isZero not] 
	whileTrue: [beginning := self findEndOfString: aString startingAt: end	].

	^result contents! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
surroundedByDoubleQuotes
	"Answer the receiver with leading and trailing quotes.  "

	^ $" asString, self, $" asString! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
symbol

	^ self asString asSymbol! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 5/26/2011 15:58'!
synonymsOf: aSymbol

	| s |
	
	s := ((self transitiveChainAt: aSymbol) last: 2) first.

	^ {s}, (self keys select: [:k |
			k ~~ s and: [(self transitiveChainAt: k) pointsTo: s]])! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:17'!
target
	"answer the receiver's target"
	^ target! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:17'!
target: anObject 
	"change the receiver's target"
	target := anObject! !

!MouseInputArea methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:13'!
temporary

	^ self hasProperty: #temporary.
	
	! !

!Process class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
terminateAllNamed: aString

	^ (self allNamed: aString) do: [:p | p terminate]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/25/2010 21:46'!
thenAction

	^ self valueOfProperty: #then
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
thenAction: aMessageSendOrASelector

	self setProperty: #then toValue: aMessageSendOrASelector
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
thumbnailForPageSorter

	^ (BookPageThumbnailMorph new) page: self! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
timeProfileDisplay

	| canvas |

	canvas := FormCanvas extent: 2000@1000.
	TimeProfileBrowser spyOn: [100 timesRepeat: [self drawOn: canvas]].
! !

!Dictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 8/16/2012 22:21'!
toggleAtKey: anObject

	self at: anObject put: (self at: anObject) not
! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
toggleProperty: aSymbol

	self setProperty: aSymbol
		  toValue: ((self hasProperty: aSymbol) not)
					! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/6/2010 21:50'!
toggleProperty: aSymbol then: bSymbol

	self toggleProperty: aSymbol.
	
	bSymbol isSymbol ifTrue: [^self perform: bSymbol].
	bSymbol value.

					! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
topCenter: aPoint

	self center: aPoint.
	self top: aPoint y! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
topMostOwner
	
	^ (self ownerChain select: [:m | m notNil]) last! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 1/6/2011 20:23'!
transitiveChainAt: anObject

	| s all |

	s := self at: anObject ifAbsent: [^ {anObject}].
	all := OrderedCollection with: anObject.
	[all includes: s] whileFalse: [
		all add: s.
		s := self at: s ifAbsent: [^ all asArray]].
	^ all asArray! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 1/5/2014 21:41'!
transitiveKeys

	^ self keys select: [:s | self includesKey: (self at: s)]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 6/7/2011 20:59'!
transitivelyAt: anObject

	^ self transitivelyAt: anObject ifAbsent: [self error: 'key not found: ', anObject]! !

!IdentityDictionary methodsFor: '*People-spfa-utils' stamp: 'spfa 1/2/2012 15:32'!
transitivelyAt: anObject ifAbsent: aBlock

	| s all |

	s := self at: anObject ifAbsent: [^ aBlock value].
	s isSymbol ifFalse: [^ s].
	all := IdentitySet new.
	[all includes: s] whileFalse: [
		all add: s.
		s := self at: s ifAbsent: [^ s]].
	^ s! !

!Float class methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 12/13/2010 13:29'!
turn

	"http://tauday.com
	http://en.wikipedia.org/wiki/Turn:=%28geometry%29"

	^ Twopi! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/23/2012 11:39'!
unCamelled

	^ self unCamelledWith: $ ! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/23/2012 11:39'!
unCamelledWith: aCharacter
	| stream  |
	stream := WriteStream on: (self species new: self size * 2).
	self doWithIndex: [:c :i |
		(c isUppercase or: [c isDigit])
			ifTrue: [
				i > 1 ifTrue: [stream nextPut: aCharacter]. 
				stream nextPut: c asLowercase]
			ifFalse: [stream nextPut: c].
	].
	^stream contents! !

!Interval class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
unbound
	
	^ Float infinity negated to: Float infinity! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
uncollapsedMorph
	^uncollapsedMorph! !

!Rectangle class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
unit

	^ (0@0) corner: (1@1)! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 12/6/2010 13:39'!
up

	^ self top max: self bottom! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
updateBox: anIconMorph color: aColor 

	(self wantsCloseBox not
		and: [anIconMorph == closeBox]) ifTrue: [^ self].	
			
	super 	updateBox: anIconMorph color: aColor ! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
usualFile

	^ self valueOfProperty: #lastFileNameWhenSaved! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:13'!
usualFile: aFileName

	self setProperty: #lastFileNameWhenSaved toValue: aFileName.! !

!ScrollPane methodsFor: '*People-spfa-utils' stamp: 'spfa 5/22/2013 14:46'!
vScrollBar
	
	^ scrollBar! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/27/2011 16:53'!
variance

	| m |
	
	m := self mean.

	^ (self inject: 0 into: [:s :ea | s + ((ea - m) raisedTo: 2)]) / self size! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/22/2010 22:14'!
verticalAxis

	^ self center x! !

!Float methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 11/30/2013 23:07'!
veryCloseTo: num
 	"are these two numbers very close?"

	^ self closeTo: num

"	num isNumber ifFalse: [^[self = num] ifError: [false]].
	self = 0.0 ifTrue: [^num abs < 0.0000001].
	num = 0 ifTrue: [^self abs < 0.0000001].
	^self = num asFloat
		or: [(self - num) abs / (self abs max: num abs) < 0.0000001]"! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 3/24/2013 17:18'!
veryCloseTo: anInterval

	^ (start veryCloseTo: anInterval start) and: [stop veryCloseTo: anInterval stop]! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 3/24/2013 16:53'!
veryCloseTo: num
	"are these two numbers close?"

	num isFloat ifTrue: [^ num veryCloseTo: self asFloat].
	^[self = num] ifError: [false]! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 3/24/2013 17:28'!
veryCloseTo: anObject

	^[self = anObject] ifError: [false]! !

!Point methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 3/24/2013 17:18'!
veryCloseTo: aPoint

	^ (x veryCloseTo: aPoint x) and: [y veryCloseTo: aPoint y]! !

!TranscriptStream methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
visible

	"Transcript visible show: 'hello'"

	World findATranscript: nil.! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
wantsCloseBox
	
	^ (self hasProperty: #noCloseBox) not! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:08'!
wantsCloseBox: aBoolean
	
	self setProperty: #noCloseBox toValue: aBoolean not! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:13'!
wantsDroppedMenu

	^ false! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 11/18/2009 18:09'!
wantsDroppedMorph: dropee event: evt

	^ true
		
! !

!MIDIFileDumperMorph methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2010 22:00'!
wantsDroppedMorph: dropee event: evt

	^ dropee isMGraphElement
		! !

!TransferGetter methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:17'!
wantsDroppedMorph: dropee event: evt

	^ dropee isTransferMorph
		! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 9/29/2012 09:54'!
wantsUsualWindowMenu

	^ true! !

!TranscriptStream methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
warn: anObject

	self visible cr; show: anObject; cr.! !

!Collection methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:08'!
whenEmpty: aBlock

	^ self isEmpty ifTrue: aBlock ifFalse: [self]! !

!CompiledMethod methodsFor: '*People-spfa-utils' stamp: 'dvf 8/23/2003 11:50'!
who
	"Answer an Array of the class in which the receiver is defined and the 
	selector to which it corresponds."

	| sel |
	self systemNavigation allBehaviorsDo: 
			[:class | 
			(sel := class methodDict keyAtIdentityValue: self ifAbsent: [nil]) 
				ifNotNil: [^Array with: class with: sel]].
	^Array with: #unknown with: #unknown! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:10'!
width

	^ (stop - start) abs! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:16'!
width: aNumber

	^ self origin corner: (self origin x + aNumber) @ self corner y! !

!Symbol methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:17'!
with: anArray

	anArray isCollection ifFalse: [^ self with: {anArray}].
	anArray size = self numArgs ifFalse:
		[^ self error: 'size mismatch']. 

	^ Message selector: self arguments: anArray! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/14/2010 21:36'!
with: otherCollection withIndexDo: threeArgBlock 
	"Evaluate threeArgBlock with corresponding elements from this collection and otherCollection plus their common index."
	otherCollection size = self size ifFalse: [self error: 'collections size mismatch'].
		
	1 to: self size do:
		[:index |
		threeArgBlock value: (self at: index)
						value: (otherCollection at: index)
						value: index]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/27/2013 14:42'!
withLineEndersTrimmed
	"Return a copy of the receiver from which leading and trailing blanks have been trimmed."

	| first last lec |
	
	lec := CSLineEnders complement.
	
	first := self indexOfAnyOf: lec startingAt: 1 ifAbsent: [0].
	first = 0 ifTrue: [ ^'' ]. 
	last := self lastIndexOfAnyOf: lec startingAt: self size ifAbsent: [self size].
	(first = 1 and: [ last = self size ]) ifTrue: [ ^self copy ].
	^self
		copyFrom: first
		to: last
! !

!Object methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:15'!
withMenuPrecision

	^ self precision: 3! !

!String methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 11/18/2009 18:16'!
withMenuPrecision

	^ self precision: 30! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
withMuOPrecision

	^ self precision: MuO precision! !

!Preferences class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
withPreference: prefSymbol setToValue: aBoolean do: aBlock

	| cval |

	cval := self perform: prefSymbol.
	self setPreference: prefSymbol toValue: aBoolean.
	aBlock value.
	self setPreference: prefSymbol toValue: cval! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/19/2012 15:14'!
withoutBlanks

	^ self reject: [:ea | CSSeparators includes: ea]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/6/2014 10:45'!
withoutLastCharacter: aCharacter

	self size isZero ifTrue: [^ self].
	self last == aCharacter ifTrue: [^ self allButLast].! !

!Preferences class methodsFor: '*People-spfa-utils' stamp: 'spfa 11/18/2009 18:15'!
withoutPreference: prefSymbol do: aBlock

	self withPreference: prefSymbol setToValue: false do: aBlock! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 11/18/2009 18:15'!
x

	"consistent with the usual graphic representation of imaginary numbers"

	^ self! !

!Number methodsFor: '*People-spfa-utils-maths' stamp: 'spfa 11/18/2009 18:15'!
y

	"consistent with the usual graphic representation of imaginary numbers"

	^ 0! !

!StrongButtonMorph methodsFor: 'as yet unclassified' stamp: 'spfa 8/11/2010 14:44'!
yellowButtonActivity: shiftKeyState 

	self doButtonAction! !
